Package: motifcounter
Type: Package
Title: R package for analysing TFBSs in DNA sequences
Version: 1.35.0
Date: 2017
Author: Wolfgang Kopp [aut, cre]
Suggests: knitr, rmarkdown, testthat, MotifDb, seqLogo, prettydoc
Imports: Biostrings, methods
Depends: R(>= 3.0)
Maintainer: Wolfgang Kopp <wolfgang.kopp@mdc-berlin.de>
Description: 'motifcounter' provides motif matching, motif counting
        and motif enrichment functionality based on position
        frequency matrices.
        The main features of the packages include the utilization
        of higher-order background models and accounting
        for self-overlapping motif matches when determining motif enrichment. 
        The background model allows to capture dinucleotide 
        (or higher-order nucleotide) composition adequately
        which may reduced model biases and misleading results compared
        to using simple GC background models.
        When conducting a motif enrichment analysis 
        based on the motif match count, the package
        relies on a compound Poisson distribution or alternatively
        a combinatorial model. These distribution account for self-overlapping
        motif structures as exemplified by repeat-like or palindromic motifs,
        and allow to determine the p-value and fold-enrichment for 
        a set of observed motif matches.
License: GPL-2
biocViews: Transcription,MotifAnnotation,SequenceMatching,Software
RoxygenNote: 6.0.1
VignetteBuilder: knitr
NeedsCompilation: yes
Collate: 'background_wrapper.R' 'comppoiss_wrapper.R'
        'combinatorial_wrapper.R' 'score_wrapper.R' 'count_wrapper.R'
        'enrichmentTest.R' 'forground_wrapper.R' 'markovmodel.R'
        'motifcounter-package.R' 'observed_wrapper.R' 'option.R'
        'overlap.R' 'simulate_wrapper.R' 'wrapper.R'
git_url: https://git.bioconductor.org/packages/motifcounter
git_branch: devel
git_last_commit: 9ac52e2
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
Packaged: 2025-10-31 22:58:11 UTC; biocbuild

# motifcounter - R package for analysing TFBSs in DNA sequences.

[![Travis-CI Build Status](https://travis-ci.org/wkopp/motifcounter.svg?branch=master)](https://travis-ci.org/wkopp/motifcounter)
[![Coverage Status](https://img.shields.io/codecov/c/github/wkopp/motifcounter/master.svg)](https://codecov.io/github/wkopp/motifcounter?branch=master)

This software package grew out of the work that I did to obtain my PhD.

If it is of help for your analysis, please cite 

```
  @Manual{,
    title = {motifcounter: R package for analysing TFBSs in DNA sequences},
    author = {Wolfgang Kopp},
    year = {2017},
    doi = {10.18129/B9.bioc.motifcounter}
  }
```

A detailed description of the compound Poisson model
is available in
```
@article{improvedcompound,
  title={An improved compound Poisson model for the number of motif hits in DNA sequences},
  author={Kopp, Wolfgang and Vingron, Martin},
  journal={Bioinformatics},
  pages={btx539},
  year={2017},
  publisher={Oxford University Press}
}

```

## Usage

```
# Estimate a background model on a set of sequences
bg <- readBackground(sequences, order)

# Normalize a given PFM
new_motif <- normalizeMotif(motif)

# Evaluate the scores along a given sequence
scores <- scoreSequence(sequence, motif, bg)

# Evaluate the motif hits along a given sequence
hits <- motifHits(sequence, motif, bg)

# Evaluate the average score profile
score_profile <- scoreProfile(sequences, motif, bg)

# Evaluate the average motif hit profile
hit_profile <- motifHitProfile(sequences, motif, bg)

# Compute the motif hit enrichment
enrichment <- motifEnrichment(sequences, motif, bg)
```

## Hallmarks of `motifcounter`

The `motifcounter` package facilitates the analysis of
 transcription factor binding sites (TFBSs) in DNA sequences.
It can be used to scan a set of DNA sequences for known motifs
(e.g. from TRANSFAC or JASPAR) in order to determine the positions
and enrichment of TFBSs in the sequences.

Therefore, an analysis with `motifcounter` requires as input
1. a position frequency matrix (PFM) which represents the TF affinity towards the DNA
2. a background model, which is estimated from a given DNA sequence and which
serves as a reference for the statistical analysis.
3. a desired false positive level, for identifying putative TFBSs in DNA sequences. For example, a reasonable choice would be to choose a false positive level such that only one in 1000 positions are called TFBSs falsely.
4. a given DNA sequence, which is subject to the TFBS analysis.

The package aims to improve motif hit enrichment analysis. To this end,
the package offers a number of features:
1. `motifcounter` supports the use of **higher-order Markov models**
to account for the sequence composition in unbound DNA segments.
This improves the reliability of the enrichment analysis, because higher-order
sequence features occur commonly in natural DNA sequences (e.g. CpG islands).
2. The package automatically accounts for **self-overlapping** motif
structures<sup><a href="#fn1" id="ref1">1</a></sup>. This aspect is important
for reducing the false positives obtained from the enrichment test, which is
prevalent for repeat-like and palindromic motifs.
`motifcounter` not only determines self-overlapping motif hit occurrences
on a single DNA strand, but (by default)
also with respect to the reverse strand.

### Enrichment model
`motifcounter` implements two analytic approximations of the
*distribution of the number of motif hits*
in random DNA sequences that can optionally be used for the
enrichment test:

1. A *compound Poisson approximation*
2. A *combinatorial approximation*

Both approximations yield highly accurate results for stringent
false positive levels.
Moreover, if you intend to analyse long DNA sequences or
a large set of individual sequences (total sequence length >10kb),
we recommend to use the *compound Poisson approximation*.
On the other hand, we recommend the *combinatorial approximation*
if a relaxed false positive level is prefered to identify TFBSs.




## Installation
An easy way to install `motifcounter` is by facilitating
the `devtools` R package.

```R
#install.packages("devtools")
library(devtools)
install_github("wkopp/motifcounter", build_vignettes=TRUE)
```

Alternatively, the package can also be cloned or 
downloaded from this github-rep,
built via `R CMD build`
and installed via the `R CMD INSTALL` command.

## Getting started

The `motifcounter` package contains a tutorial that illustrates:
1. how to determine position- and strand-specific TF motif binding sites,
2. how to analyse the profile of motif hit occurrences across a set of
aligned sequences, and
3. how to test for motif enrichment in a given set of sequences.

The tutorial can be found in the package-vignette:

```R
library(motifcounter)
vignette("motifcounter")
```

## Acknowledgements
Thanks to [matthuska](https://github.com/matthuska) for reviewing and commenting
on the package.
<hr></hr>
<sup id="fn1">1: Self-overlapping motifs induce
**clumps of motif hits** (that is, mutually
overlapping motif hits) when a DNA sequence is scanned for hits.
As a consequence of **motif clumping**, the distribution of the number of
motif hits, and thus, the enrichment test are affected.<a href="#ref1" title="Jump back to footnote 1 in the text.">↩</a></sup>

#' Set parameters for the enrichment analysis
#'
#' This function sets some global parameters for
#' the `motifcounter` package.
#'
#' alpha=0.001 amounts to calling 
#' one motif hit per strand by chance in a sequence of length 1000 bp. 
#' Decreasing gran will increase number
#' of discrete bins that represent the real-valued score range.
#' This will yield more a accurate score distribution due to less
#' discretization noise, however, it incurs an 
#' increase of the computational burden.
#' 
#' @param alpha Numeric False positive probabililty for calling
#' motif hits by chance. Default: alpha = 0.001
#' @param gran Numeric score granularity which is used
#' for discretizing the score range. Default: gran = 0.1
#' @param ncores Interger number of cores used for parallel processing,
#' if openMP is available. Default: ncores = 1
#'
#' @return None
#' @examples
#'
#' # Prescribe motifcounter Options
#' motifcounterOptions(alpha = 0.001, gran = 0.1, ncores = 1)
#'
#' @export
motifcounterOptions = function(alpha = 0.001, gran = 0.1, ncores = 1) {
    if (alpha <= 0.0 || alpha > 1.0) {
        stop("alpha must be a probability")
    }
    if (gran <= 0.0) {
        stop("gran must be positive")
    }
    if (alpha > 0.05) {
        warning(paste(strwrap(
            "alpha is too chosen high. This might cause
            biases which could lead to false conclusions 
            when using the 'motifEnrichment'.
            Consider prescribing a smaller alpha with 
            'motifcounterOptions()'."),
            collapse = "\n"))
    }
    dummy = .C(
        motifcounter_option,
        as.numeric(alpha),
        as.numeric(gran),
        as.integer(ncores)
    )
}

#' Retrieve the false positive probability
#'
#' This function returns the current false positive level for
#' calling motif hits in random sequences.
#' 
#' The returned value is usually slightly smaller than
#' the prescribed `alpha` in `motifcounterOptions`, because
#' of the discrete nature of sequences.
#'
#'
#' @return False positive probability
#'
#' @examples
#' motifcounter:::sigLevel()
#'
sigLevel = function() {
    alpha = 0.0
    ret = .C(motifcounter_siglevel, alpha)
    return(ret[[1]])
}

context("setup")

test_that("motifcounterOptions", {
    # negative alpha
    expect_error(motifcounterOptions(-1))
    # too large alpha
    expect_error(motifcounterOptions(3))
    # warning with large alpha
    expect_warning(motifcounterOptions(.4))
    # negative granularity
    expect_error(motifcounterOptions(.01,-1))
    # zero granularity
    expect_error(motifcounterOptions(.01,0.0))

    # retrieve alpha
    alpha=0.01
    motifcounterOptions(alpha)
    expect_equal(alpha,sigLevel())
})

context("Combinatorial model")

test_that("combinatorialDist", {
    # inital settings

    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # Obtain background
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,1)

    # Obtain motif
    pwmname="x3.tab"
    motiffile=system.file("extdata",pwmname, package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # overlapping hit probs
    op=probOverlapHit(motif,bg)

    # Dist must sum to one
    # single seq
    expect_equal(sum(combinatorialDist(100, op)$dist),1)
    expect_true(combinatorialDist(100, op)$dist[1]<1)
    # multiple seqs
    expect_equal(sum(combinatorialDist(rep(100,10), op)$dist),1) 
    expect_true(combinatorialDist(rep(100,10), op)$dist[1]<1) 

    # Error with variable length seq
    expect_error(combinatorialDist(30:100,op)) # variable length sequences

    # Warning with short seqs
    expect_warning(combinatorialDist(29,op)) # sequence too short warning

    # Error with too short sequences
    expect_equal(combinatorialDist(ncol(motif)-1,op)$dist[1],1)
    expect_equal(combinatorialDist(-1,op)$dist[1],1)
    expect_equal(combinatorialDist(0,op)$dist[1],1)

    # Single stranded not supported
    op=probOverlapHit(motif,bg,singlestranded=TRUE)
    expect_error(combinatorialDist(10,op)) # single strand not supported

})

context("Enrichment")

test_that("motifEnrichment", {
    # init
    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # Load Sequences
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs,1)

    # Load motif
    pwmname="x3.tab"
    motiffile=system.file("extdata",pwmname, package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # test short sequence
    for (method in c("compound", "combinatorial")) {
         for (ss in c(TRUE,FALSE)) {
            bg=readBackground(seqs,1)
            expect_equal(motifEnrichment(Biostrings::DNAStringSet(""),
                        motif,bg, method=method, singlestranded=ss)[[1]],1)
            expect_true(is.na(motifEnrichment(Biostrings::DNAStringSet(""),
                        motif,bg, method=method, singlestranded=ss)[[2]]))
            expect_equal(motifEnrichment(
                        generateDNAStringSet(ncol(motif)-1,bg),
                        motif,bg, method=method, singlestranded=ss)[[1]],1)
            expect_true(is.na(motifEnrichment(
                        generateDNAStringSet(ncol(motif)-1,bg),
                        motif,bg, method=method, singlestranded=ss)[[2]]))

            # check motif shorter than bg order
            bg=readBackground(seqs,2)
            expect_error(motifEnrichment(seqs,as.matrix(motif[, 1]),bg)[[1]])
        }
    }

    # check wrong method
    expect_error(motifEnrichment(seqs,motif,bg,singlestranded=TRUE,
                    method="tata"))

    bg=readBackground(seqs,1)
    # run enrichment in different flavours
    m=motifEnrichment(seqs,motif,bg)
    expect_true(m[[1]]<1)
    expect_true(m[[1]]>=0)
    expect_true(is.numeric(m[[2]]))

    m=motifEnrichment(seqs,motif,bg,singlestranded=TRUE)
    expect_true(m[[1]]<1)
    expect_true(m[[1]]>=0)
    expect_true(is.numeric(m[[2]]))

    m=motifEnrichment(seqs,motif,bg,method="combinatorial")
    expect_true(m[[1]]<1)
    expect_true(m[[1]]>=0)
    expect_true(is.numeric(m[[2]]))

    # not supported
    expect_error(motifEnrichment(seqs,motif,bg,singlestranded=TRUE,
                    method="combinatorial"))

    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs2=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs2,2)
    seqfile=system.file("extdata","test2.fa", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    
    
    expect_error(motifEnrichment(seqs,motif,bg))
    expect_equal(motifEnrichment(seqs[1:2],motif,bg)$pvalue, 0.1293926, tolerance=0.000001)
    
})

context("Overlap")

test_that("probOverlaphit", {

    motifcounterOptions()

    # Obtain sequence
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Obtain background
    bg=readBackground(seqs,1)

    # Obtain motif
    motiffile=system.file("extdata","x31.tab", package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))


    op=probOverlapHit(motif,bg,singlestranded=FALSE)
    expect_equal(op@alpha,0.0008473007,tolerance=1e-7)
    expect_equal(op@alpha, op@gamma[1])
    expect_equal(op@beta[1],0.0)
    expect_equal(op@beta3p[1],1.0)
    expect_equal(op@beta5p[5],3.940588e-02)

    op=probOverlapHit(motif,bg,singlestranded=TRUE)
    expect_equal(op@alpha,0.0008473007,tolerance=1e-7)
    expect_equal(op@alpha, op@gamma[1])
    expect_equal(op@beta[1],0.0)
    expect_equal(op@beta3p,rep(0,length(op@beta3p)))
    expect_equal(op@beta5p,rep(0,length(op@beta5p)))

})

#' Combinatrial model approximation of the number of motif hits
#'
#' This function approxmiates the distribution of the number of motif hits.
#' To this end, it sums over all combinations of obtaining k hits 
#' in a random sequence of a given length using an efficient 
#' dynamic programming algorithm.
#'
#' This function is an alternative to \code{\link{compoundPoissonDist}}
#' which requires fixed-length sequences and currently
#' only supports the computation of 
#' the distribution of the number of hits when both
#' DNA strands are scanned for motif hits.
#' 
#' @include comppoiss_wrapper.R
#'
#' @inheritParams compoundPoissonDist
#'
#' @return List containing
#' \describe{
#' \item{dist}{Distribution of the number of hits}
#' }
#' @seealso \code{\link{compoundPoissonDist}}
#' @seealso \code{\link{numMotifHits}}
#' @seealso \code{\link{probOverlapHit}}
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#' 
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Load background model
#' bg = readBackground(seqs, 1)
#'
#' # Compute overlap probabilities
#' op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)
#'
#' # Use 2 sequences of length 100 bp each
#' seqlen = rep(100, 2) 
#'
#' # Computes the combinatorial distribution of the number of motif hits
#' dist = motifcounter:::combinatorialDist(seqlen, op)
#'
combinatorialDist = function(seqlen, overlap) {
    stopifnot(is(overlap, "Overlap"))
    
    # Length must be at least as long as the motif
    if (seqlen[1] - length(getBeta(overlap)) + 1 <= 0) {
        return (list(dist = 1))
    }
    
    # The remaining sequence must be of equal length!
    if (!all(seqlen == seqlen[1])) {
        stop("All elements in 'seqlen' must be equal.")
    }
    
    if (getSinglestranded(overlap) == TRUE) {
        # This might change in the future though
        stop(
            paste(strwrap("The combinatorial model can only be used
            with 'singlestranded = FALSE' (see probOverlapHit)."), 
            collapse = "\n")
        )
    }
    
    # Analysing too short sequences might result in biases
    # of the model
    if (seqlen[1] < 30) {
        warning(paste(strwrap(
            "seqlen[1] < 30 bp: Short sequences might incur
            biases in the analysis.
            If possible, use longer sequences (e.g. seqlen[1] >= 100)."), 
            collapse="\n")
        )
    }
    
    # the maximal number of hits is given by the sequence length
    maxhits = seqlen[1]
    
    # allocate the distribution of the number of hits
    # across multiple sequences
    totalmaxhits = maxhits * length(seqlen)
    dist = numeric(totalmaxhits + 1)
    
    ret = .C(
        motifcounter_combinatorialDist,
        getAlpha(overlap),
        getBeta(overlap),
        getBeta3p(overlap),
        getBeta5p(overlap),
        as.numeric(dist),
        as.integer(seqlen[1]),
        as.integer(maxhits),
        as.integer(length(seqlen)),
        length(getBeta(overlap)),
        as.integer(getSinglestranded(overlap))
    )
    
    if (is.na(sum(ret[[5]]))) {
        # This might be the case if too stringent
        # and too long or too many sequences shall be
        # assessed for significant enrichment.
        # In this case, the combinatorial model is pushed
        # to its limits
        stop(
            paste(strwrap("Numerical issue detected.
            Please try to reduce the number (see 'length(seqlen)') and/or 
            length of sequences (see 'seqlen[1]'). Alternatively,
            please try to use the 'compound Poisson approximation' 
            instead of the 'combinatorial approximation'."), 
            collapse = "\n")
        )
    }
    return(list(dist = ret[[5]]))
}

## ----include=FALSE------------------------------------------------------------
library(knitr)
knit_hooks$set(plot = function(x, options) {
    paste('<figure><img src="',
        opts_knit$get('base.url'), paste(x, collapse = '.'),
        '"><figcaption>', options$fig.cap, '</figcaption></figure>',
        sep = '')
})
library(motifcounter)
library(MotifDb)
library(seqLogo)
opts_chunk$set(fig.path="fig/")

## ----eval=FALSE---------------------------------------------------------------
# # Estimate a background model on a set of sequences
# bg <- readBackground(sequences, order)

## ----eval=FALSE---------------------------------------------------------------
# # Normalize a given PFM
# new_motif <- normalizeMotif(motif)

## ----eval=FALSE---------------------------------------------------------------
# # Evaluate the scores along a given sequence
# scores <- scoreSequence(sequence, motif, bg)

## ----eval=FALSE---------------------------------------------------------------
# # Evaluate the motif hits along a given sequence
# hits <- motifHits(sequence, motif, bg)

## ----eval=FALSE---------------------------------------------------------------
# # Evaluate the average score profile
# average_scores <- scoreProfile(sequences, motif, bg)

## ----eval=FALSE---------------------------------------------------------------
# # Evaluate the average motif hit profile
# average_hits <- motifHitProfile(sequences, motif, bg)

## ----eval=FALSE---------------------------------------------------------------
# # Compute the motif hit enrichment
# enrichment_result <- motifEnrichment(sequences, motif, bg)

## -----------------------------------------------------------------------------
order <- 1
file <- system.file("extdata", "seq.fasta", package = "motifcounter")
seqs <- Biostrings::readDNAStringSet(file)
bg <- readBackground(seqs, order)

## -----------------------------------------------------------------------------
# Extract the Oct4 motif from MotifDb
library(MotifDb)
oct4 <- as.list(query(query(query(MotifDb, "hsapiens"), 
                "pou5f1"), "jolma2013"))[[1]]
motif <- oct4

# Visualize the motif using seqLogo
library(seqLogo)
seqLogo(motif)

## -----------------------------------------------------------------------------
new_motif <- normalizeMotif(motif)

## ----eval=FALSE---------------------------------------------------------------
# alpha <- 0.01
# motifcounterOptions(alpha)

## -----------------------------------------------------------------------------
file <- system.file("extdata", "oct4_chipseq.fa", package = "motifcounter")
oct4peaks <- Biostrings::readDNAStringSet(file)

## ----fig.show=TRUE, fig.cap="Per-position and strand scores"------------------
# Determine the per-position and per-strand scores
scores <- scoreSequence(oct4peaks[[1]], motif, bg)

# As a comparison, compute the theoretical score distribution
sd <- scoreDist(motif, bg)

par(mfrow = c(1, 2))
# Plot the observed scores, per position and per strand
plot(1:length(scores$fscores), scores$fscores, type = "l", 
    col = "blue", xlab = "position", ylab = "score", 
    ylim = c(min(sd$score), max(sd$score)), xlim = c(1, 250))
points(scores$rscores, col = "red", type = "l")
legend("topright", c("forw.", "rev."), col = c("blue", "red"), lty = c(1, 1))

# Plot the theoretical score distribution for the comparison
plot(sd$dist, sd$scores, type = "l", xlab = "probability", ylab = "")

## -----------------------------------------------------------------------------
# Call putative TFBSs
mhits <- motifHits(oct4peaks[[1]], motif, bg)

# Inspect the result
fhitpos <- which(mhits$fhits == 1)
rhitpos <- which(mhits$rhits == 1)
fhitpos
rhitpos

## -----------------------------------------------------------------------------
oct4peaks[[1]][rhitpos:(rhitpos + ncol(motif) - 1)]

## -----------------------------------------------------------------------------
# Prescribe a new false positive level for calling TFBSs
motifcounterOptions(alpha = 0.01)

# Determine TFBSs
mhits <- motifHits(oct4peaks[[1]], motif, bg)

fhitpos <- which(mhits$fhits == 1)
rhitpos <- which(mhits$rhits == 1)
fhitpos
rhitpos

## ----fig.show=TRUE, fig.cap="Average score profile"---------------------------
# Determine the average score profile across all Oct4 binding sites
scores <- scoreProfile(oct4peaks, motif, bg)

plot(1:length(scores$fscores), scores$fscores, type = "l", 
    col = "blue", xlab = "position", ylab = "score")
points(scores$rscores, col = "red", type = "l")
legend("bottomleft", legend = c("forward", "reverse"), 
    col = c("blue", "red"), lty = c(1, 1))

## ----fig.show=TRUE, fig.cap="Average motif hit profile"-----------------------
motifcounterOptions()  # let's use the default alpha=0.001 again

# Determine the average motif hit profile
mhits <- motifHitProfile(oct4peaks, motif, bg)

plot(1:length(mhits$fhits), mhits$fhits, type = "l", 
    col = "blue", xlab = "position", ylab = "score")
points(mhits$rhits, col = "red", type = "l")
legend("bottomleft", legend = c("forward", "reverse"), 
    col = c("blue", "red"), lty = c(1, 1))

## -----------------------------------------------------------------------------
# Enrichment of Oct4 in Oct4-ChIP-seq peaks
result <- motifEnrichment(oct4peaks[1:10], motif, bg)
result

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' Check valididity of PFM
#'
#' This function checks if the PFM is valid. The function throws
#' an error if the R matrix does not represent a PFM.
#'
#' @param pfm An R matrix that represents a position frequency matrix
#' @return None
#'
#' @examples
#'
#' # Load motif
#' motiffile = system.file("extdata", "x1.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Check validity
#' motifcounter:::motifValid(motif)
#'
motifValid = function(pfm) {
    stopifnot(is.matrix(pfm))

    #check if matrix has four rows
    stopifnot(nrow(pfm) == 4)

    #check if all entries are positive
    if (!all(pfm > 0)) {
        stop("pfm must be strictly positive. Use 'normalizeMotif'.")
    }
    #check if all columns sum to one
    if (!all(abs(1 - colSums(pfm)) < 0.0000001)) {
        stop("Columns must sum to one. Use 'normalizeMotif'.")
    }
}

#' Normalizes a PFM
#'
#' This function normalizes a PFM and optionally
#' adds pseudo-evidence to each entry of the matrix.
#'
#' @inheritParams motifValid
#' @param pseudo Small numeric pseudo-value that is added
#' to each entry in the PFM in order to ensure strictly positive entries.
#' Default: pseudo = 0.01
#' @return A normalized PFM
#'
#' @examples
#'
#' # Load motif
#' motiffile = system.file("extdata", "x1.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Normalize motif
#' new_motif = normalizeMotif(motif)
#'
#' @export
normalizeMotif = function(pfm, pseudo = 0.01) {
    pfm = pfm + pseudo
    pfm = t(t(pfm) / colSums(pfm))
    return(pfm)
}

#' Check valididity of PFM with background
#'
#' This function checks if the PFM x background combination is valid.
#' The function throws an error if this is not the case.
#'
#' @inheritParams motifValid
#' @template templates
#' @return None
#'
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x1.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Check validity
#' motifcounter:::motifAndBackgroundValid(motif, bg)
#'
motifAndBackgroundValid = function(pfm, bg) {
    if (ncol(pfm) < getOrder(bg)) {
        stop(paste(strwrap("ncol(pfm) must be greater or equal
            to the background model order (see order-slot of 
            the Background object)"),
            collapse = "\n"))
    }
}

#' Reverse complements a PFM
#'
#' This function computes the reverse complement of a given PFM.
#'
#' @inheritParams motifValid
#' @return Reverse complemented PFM
#'
#' @examples
#'
#' # Load motif
#' motiffile = system.file("extdata", "x1.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Reverse complement motif
#' revcompmotif = motifcounter:::revcompMotif(motif)
#'
revcompMotif = function(pfm) {
    nrows = nrow(pfm)
    ncols = ncol(pfm)
    cpfm = matrix(rev(as.vector(pfm)), nrow = nrows, ncol = ncols)
    return(cpfm)
}

context("Motif tests")

test_that("motif validity",
{
    # Read motif
    motiffile=system.file("extdata","x1.tab", package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))
    motifValid(motif)

    # not a matrix
    expect_error(motifValid("hallo"))

    #wrong dimensionality
    expect_error(motifValid(t(motif)))

    # provoke wrong nomalization
    motif[1,1]=0
    expect_error(motifValid(motif))
    
    # renormalize to solve the issue
    motifValid(normalizeMotif(motif))
    
    # provoke wrong nomalization
    motif[1,1]=.1
    expect_error(motifValid(motif))

    # renormalize to solve the issue
    motifValid(normalizeMotif(motif))

    # test reverse complement
    expect_equal(as.vector(motif), as.vector(revcompMotif(revcompMotif(motif))))
})

#' Overlap class definition
#'
#' Objects of this class serve as a container that holds
#' parameters for the overlapping hit probabilities.
#'
#' An Overlap object is constructed via the \code{\link{probOverlapHit}}
#'
#' @slot alpha Scalar numeric significance level to call motif matches
#' @slot beta Numeric vector of 
#'              principal overlapping hit probabilities on the same strand.
#' @slot beta3p Numeric vector of
#'              principal overlapping hit probabilities with 3'-overlap.
#' @slot beta5p Numeric vector of
#'              principal overlapping hit probabilities with 5'-overlap.
#' @slot gamma Numeric vector of marginal overlapping hit probabilities.
#' @slot singlestranded logical flag to indicate whether one
#'              or both strands are scanned for motif matches.
.Overlap <- setClass("Overlap",
    slots = c(
                alpha = "numeric",
                beta = "numeric",
                beta3p = "numeric",
                beta5p = "numeric",
                gamma = "numeric",
                singlestranded = "logical"
            )
)

#' Accessor to slot alpha
#'
#' @param obj An Overlap object
#'
#' @return alpha slot
getAlpha = function(obj) {
    return(obj@alpha)
}

#' Accessor to slot beta
#'
#' @param obj An Overlap object
#'
#' @return beta slot
getBeta = function(obj) {
    return(obj@beta)
}

#' Accessor to slot beta
#'
#' @param obj An Overlap object
#'
#' @return beta5p slot
getBeta5p = function(obj) {
    return(obj@beta5p)
}

#' Accessor to slot beta3p
#'
#' @param obj An Overlap object
#'
#' @return beta3p slot
getBeta3p = function(obj) {
    return(obj@beta3p)
}

#' Accessor to slot gamma
#'
#' @param obj An Overlap object
#'
#' @return gamma slot
getGamma = function(obj) {
    return(obj@gamma)
}

#' Accessor to slot singlestranded
#'
#' @param obj An Overlap object
#'
#' @return singlestranded slot
getSinglestranded = function(obj) {
    return(obj@singlestranded)
}

#' Overlapping motif hit probabilities
#'
#' This function computes a set of self-overlapping probabilites for a
#' motif and background model.
#' 
#' The `gamma`s are determined based on two-dimensional score 
#' distributions (similar as described in Pape et al. 2008),
#' however, they are computed based on an order-d background model.
#' On the other hand, the `beta`s represent overlapping hit probabilities
#' that were corrected for intermediate hits.
#' 
#' @inheritParams numMotifHits
#' @return An Overlap object
#'
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute overlapping hit probabilities for scanning both DNA strands
#' op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)
#'
#' # Compute overlapping hit probabilities for scanning a single DNA strand
#' op = motifcounter:::probOverlapHit(motif, bg, singlestranded = TRUE)
#'
probOverlapHit = function(pfm, bg, singlestranded = FALSE) {
    #check if pfm is a matrix
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)

    alpha = numeric(1)
    beta = numeric(ncol(pfm))
    beta3p = numeric(ncol(pfm))
    beta5p = numeric(ncol(pfm))
    gamma = numeric(3 * ncol(pfm))
    if (singlestranded == TRUE) {
        res = .C(
            motifcounter_overlapSingleStranded,
            as.numeric(pfm),
            nrow(pfm),
            ncol(pfm),
            as.numeric(alpha),
            as.numeric(beta),
            as.numeric(beta3p),
            as.numeric(beta5p),
            as.numeric(gamma),
            as.numeric(getStation(bg)),
            as.numeric(getTrans(bg)),
            as.integer(getOrder(bg))
        )
    } else {
        res = .C(
            motifcounter_overlap,
            as.numeric(pfm),
            nrow(pfm),
            ncol(pfm),
            as.numeric(alpha),
            as.numeric(beta),
            as.numeric(beta3p),
            as.numeric(beta5p),
            as.numeric(gamma),
            as.numeric(getStation(bg)),
            as.numeric(getTrans(bg)),
            as.integer(getOrder(bg))
        )
    }
    overlap = .Overlap(
        alpha = res[[4]],
        beta = res[[5]],
        beta3p = res[[6]],
        beta5p = res[[7]],
        gamma = res[[8]],
        singlestranded = singlestranded
    )
    return (overlap)
}

context("Markov model")

test_that("markovModel", {
    # inital settings

    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # Obtain background
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,1)

    # Obtain motif
    pwmname="x3.tab"
    motiffile=system.file("extdata",pwmname, package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # overlapping hit probs
    op=probOverlapHit(motif,bg, singlestranded = TRUE)
    #print(getAlpha(op))

    # Dist must sum to one
    # single seq
    val = rep(0, ncol(motif))
    val[1] = 1
    expect_equal(markovModel(op, 0)$dist, val)

    expect_equal(sum(markovModel(op, 1)$dist), 1)
    expect_equal(sum(markovModel(op, 10)$dist), 1)
    expect_equal(sum(markovModel(op, 100)$dist), 1)


    # overlapping hit probs
    op=probOverlapHit(motif,bg, singlestranded = FALSE)

    # Dist must sum to one
    # single seq
    val = rep(0, ncol(motif)*2 + 2)
    val[1] = 1
    expect_equal(markovModel(op, 0)$dist, val)

    expect_equal(sum(markovModel(op, 1)$dist), 1)
    expect_equal(sum(markovModel(op, 10)$dist), 1)
    expect_equal(sum(markovModel(op, 100)$dist), 1)

})

test_that("clumpStartProbSingleStranded", {
    # inital settings

    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # Obtain background
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,1)

    # Obtain motif
    pwmname="x32.tab" # palindrom
    motiffile=system.file("extdata",pwmname, package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # overlapping hit probs
    op=probOverlapHit(motif,bg, singlestranded = TRUE)
    expect_true(computeClumpStartProb(op)<getAlpha(op))

    pwmname="x21.tab" # A-repeat
    motiffile=system.file("extdata",pwmname, package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # overlapping hit probs
    op=probOverlapHit(motif,bg, singlestranded = TRUE)
    expect_true(computeClumpStartProb(op)<getAlpha(op))

    pwmname="x1.tab" # Non-self-overlapping
    motiffile=system.file("extdata",pwmname, package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # overlapping hit probs
    op=probOverlapHit(motif,bg, singlestranded = TRUE)
    expect_true(computeClumpStartProb(op)>getAlpha(op))

    pwmnames = c("x32.tab", "x21.tab", "x1.tab")

    for (pwmname in pwmnames) {
        motiffile=system.file("extdata",pwmname, package="motifcounter")
        motif=t(as.matrix(read.table(motiffile)))

        # overlapping hit probs
        op=probOverlapHit(motif,bg, singlestranded = TRUE)
        alpha = getAlpha(op)
        #print(computeClumpStartProb(op))
        op@alpha = computeClumpStartProb(op)
        expect_equal(markovModel(op, 100)$dist[2], alpha)
    }


})


test_that("clumpStartProbDoubleStranded", {
    # inital settings

    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # Obtain background
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,1)

    # Obtain motif
    pwmname="x32.tab" # palindrom
    motiffile=system.file("extdata",pwmname, package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # overlapping hit probs
    op=probOverlapHit(motif,bg, singlestranded = FALSE)
    expect_true(computeClumpStartProb(op)<getAlpha(op))

    pwmname="x21.tab" # A-repeat
    motiffile=system.file("extdata",pwmname, package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # overlapping hit probs
    op=probOverlapHit(motif,bg, singlestranded = FALSE)
    expect_true(computeClumpStartProb(op)<getAlpha(op))

    pwmnames = c("x32.tab", "x21.tab", "x1.tab")

    for (pwmname in pwmnames) {
        motiffile=system.file("extdata",pwmname, package="motifcounter")
        motif=t(as.matrix(read.table(motiffile)))

        # overlapping hit probs
        op=probOverlapHit(motif,bg, singlestranded = FALSE)
        alpha = getAlpha(op)
        #print(computeClumpStartProb(op))
        op@alpha = computeClumpStartProb(op)
        dist = markovModel(op, 100)$dist
        expect_equal(dist[2] + dist[3], 2*alpha)
    }
})

#' Markov model for generating Y_1Y_2_Y3 ...
#'
#' This function implements the Markov model for producing
#' motif matches. The function takes a state probability vector
#' and uses the transition probabilities in order to obtain
#' the state probability at the next time point.
#' This function is used used to determine the stationary distribution
#' of the states.
#'
#' The R interface is only used for the purpose of testing
#' the correctness of the model.
#'
#' @include comppoiss_wrapper.R
#'
#' @inheritParams compoundPoissonDist
#' @param nsteps Number of state transitions to perform
#'
#' @return List containing
#' \describe{
#' \item{dist}{State probability distribution after the given number of steps}
#' }
#' @seealso \code{\link{compoundPoissonDist}}
#' @seealso \code{\link{numMotifHits}}
#' @seealso \code{\link{probOverlapHit}}
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Load background model
#' bg = readBackground(seqs, 1)
#'
#' # Compute overlap probabilities
#' op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)
#'
#'
#' # Computes the state probabilities of the Markov model
#' # (default: after one step)
#' dist = motifcounter:::markovModel(op)
#'
markovModel = function(overlap, nsteps = 1) {
    stopifnot(is(overlap, "Overlap"))

    if (getSinglestranded(overlap) == TRUE) {
        dist = numeric(length(getBeta(overlap)))
        # This might change in the future though
        ret = .C(
            motifcounter_markovmodel_ss,
            as.numeric(dist),
            getAlpha(overlap),
            getBeta(overlap),
            as.integer(nsteps),
            length(getBeta(overlap))
        )
    } else {
        dist = numeric(length(getBeta(overlap))*2 + 2)
        ret = .C(
            motifcounter_markovmodel_ds,
            as.numeric(dist),
            getAlpha(overlap),
            getBeta(overlap),
            getBeta3p(overlap),
            getBeta5p(overlap),
            as.integer(nsteps),
            length(getBeta(overlap))
        )
    }


    return(list(dist = ret[[1]]))
}


#' Computes the Clump start probability based on a Markov model
#'
#' This function leverages a Markov model in order to
#' determine the clump start probability.
#' The computation depends on the selected false positive probability 
#' for calling motif matches 'alpha' and the pre-determined
#' overlapping match probabilities 'beta'.
#'
#' The general idea of the method relies on the fact that
#' for the stationary distribution of the Markov model,
#' motif matches must be observed with probability 'alpha'.
#' Hence, the clump start probability 'tau' is optimized
#' to achieve that goal.
#'
#' The R interface is only used for the purpose of testing
#' the correctness of the model.
#'
#' @include comppoiss_wrapper.R
#'
#' @inheritParams compoundPoissonDist
#'
#' @return Clump start probability 'tau'
#' @seealso \code{\link{compoundPoissonDist}}
#' @seealso \code{\link{numMotifHits}}
#' @seealso \code{\link{probOverlapHit}}
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Load background model
#' bg = readBackground(seqs, 1)
#'
#' # Compute overlap probabilities
#' op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)
#'
#'
#' # Computes the clump start probability
#' dist = motifcounter:::computeClumpStartProb(op)
#'
computeClumpStartProb = function(overlap) {
    stopifnot(is(overlap, "Overlap"))

    if (getSinglestranded(overlap) == TRUE) {
        # This might change in the future though
        tau = .Call(
            motifcounter_mcss_check_optimal,
            getAlpha(overlap),
            getBeta(overlap),
            length(getBeta(overlap))
        )
    } else {
        tau = .Call(
            motifcounter_mcds_check_optimal,
            getAlpha(overlap),
            getBeta(overlap),
            getBeta3p(overlap),
            getBeta5p(overlap),
            length(getBeta(overlap))
        )
    }

    return(tau)
}

#' Background class definition
#'
#' Objects of this class serve as a container that holds
#' parameters for the Background model.
#'
#' A Background model is constructed 
#' via \code{\link{readBackground}}.
#'
#' @slot station Stationary probabilities
#' @slot trans Transition probabilities
#' @slot counts k-mer counts
#' @slot order Background model order
.Background <- setClass("Background",
    slots = c(
                station = "numeric",
                trans = "numeric",
                counts = "integer",
                order = "integer"
            ),
    validity = function(object) {
        msg <- character(0)
        # check slot dimensions
        if (length(object@station) != max(4, 4 ^ (object@order))) {
            msg <- paste(strwrap("Inconsistent Background object.
                Use readBackground() to construct a Background object."),
                collapse = "\n")
        }
        if (!length(msg) && length(object@trans) != 4 ^ (object@order + 1)) {
            msg <- paste(strwrap("Inconsistent Background object.
                Use readBackground() to construct a Background object."),
                collapse = "\n")
        }
        # check if slots are normalized
        if (!length(msg) && !isTRUE(all.equal(sum(object@station), 1))) {
            msg <- paste(strwrap("Inconsistent Background object.
                Use readBackground() to construct a Background object."),
                collapse = "\n")
        }
        if (!length(msg) && 
            !isTRUE(all.equal(sum(object@trans), 4^object@order))) {
            msg <- paste(strwrap("Inconsistent Background object.
                Use readBackground() to construct a Background object."),
                collapse = "\n")
        }
        if (length(msg)) msg else TRUE
    }
)

#' Accessor to slot station
#'
#' @param obj A Background object
#'
#' @return station slot
getStation = function(obj) {
    return(obj@station)
}
#' Accessor to slot trans
#'
#' @param obj A Background object
#'
#' @return trans slot
getTrans = function(obj) {
    return(obj@trans)
}
#' Accessor to slot counts
#'
#' @param obj A Background object
#'
#' @return counts slot
getCounts = function(obj) {
    return(obj@counts)
}
#' Accessor to slot order
#'
#' @param obj A Background object
#'
#' @return order slot
getOrder = function(obj) {
    return(obj@order)
}

#' Estimates a background model from a set of DNA sequences
#'
#' Given a set of DNA sequences and an order, this function
#' estimates an order-d Markov model which is used to characterize
#' random DNA sequences.
#'
#'
#' @inheritParams lenSequences
#' @param order Order of the Markov models that shall be used as the
#' background model. Default: order = 1.
#'
#' @return A Background object
#'
#' @examples
#'
#' # Load sequences
#' file = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(file)
#'
#' # Estimate an order-1 Markov model
#' bg = readBackground(seqs, 1)
#'
#' @export
readBackground = function(seqs, order = 1) {
    if (is(seqs, "DNAString")) {
      # wrap the sequence up as sequence set
      seqs = DNAStringSet(seqs)
    }
    stopifnot (is(seqs, "DNAStringSet"))
    stopifnot (order >= 0)
    
    trans = numeric(4 ^ (order + 1))
    
    # collect k-mer frequencies from each individual sequence
    counts = vapply(seqs, function(seq, order, trans) {
        return(
            .C(
                motifcounter_countfreq,
                toString(seq),
                length(seq),
                trans,
                as.integer(order)
            )[[3]]
        )
    }, FUN.VALUE = trans, order, trans)
    counts = rowSums(counts)
    if (order == 0) {
        station = numeric(4)
    } else {
        station = numeric(4 ^ order)
    }
    dummy = .C(
        motifcounter_bgfromfreq,
        as.numeric(counts),
        as.numeric(station),
        as.numeric(trans),
        as.integer(order)
    )
    background = .Background(
        station = dummy[[2]],
        trans = dummy[[3]],
        counts = as.integer(dummy[[1]]),
        order = as.integer(order)
    )
    return (background)
}

context("Background")

test_that("readBackground", {
    # check if all the files can be loaded without
    # syntax errors
    # this file contains variable length sequences and 'N's
    seqfile = system.file("extdata", "seq1.fasta", package = "motifcounter")
    seqs = Biostrings::readDNAStringSet(seqfile)
    
    # check if it also works with a DNAString
    bg = readBackground(seqs[[1]], 1)
    
    # Check if all background models are plausible
    # all must represent probabilities
    for (m in 0:3) {
        
        bg = readBackground(seqs, m)
        validObject(bg)
        # check if background slot dimensions are correctly checked
        bg_altered = bg
        bg_altered@station = 1
        expect_error(validObject(bg_altered))
        
        bg_altered = bg
        bg_altered@trans = 1
        expect_error(validObject(bg_altered))
        
        # check background slot normalization
        bg_altered = bg
        bg_altered@trans = rep(0, length(bg@trans))
        expect_error(validObject(bg_altered))
        
        bg_altered = bg
        bg_altered@station = rep(0, length(bg@station))
        expect_error(validObject(bg_altered))
    }

    # Check wrong order
    expect_error(readBackground(seqs, -1)) # negative order
    expect_error(readBackground(seqs, "a")) # wrong order type
    
    # Check wrong seqs class
    expect_error(readBackground(seq[[1]], 2)) # not DNAStringSet object
    
    # check short sequences
    seqs = Biostrings::DNAStringSet("a")
    
    # not all nucleotids seen
    expect_error(readBackground(Biostrings::DNAStringSet("a"), 0))
    expect_error(readBackground(Biostrings::DNAStringSet(""), 0))
    expect_error(readBackground("a", 1)) # not a DNAStringSet
    expect_error(readBackground("", 2)) # not a DNAStringSet
    
    # Check if the number of counts is correct
    seq = Biostrings::DNAStringSet("acgtaagg")
    expect_equal(readBackground(seq, 0)@counts, rep(8, 4))
    expect_equal(readBackground(seq, 1)@counts,
                 c(2, 2, 1, 2, 2, 2, 2, 1, 1, 2, 2, 2, 2, 1, 2, 2))
    
    
    # Check order-0 background for another toy sequence
    seqfile = system.file("extdata", "test.fa", package = "motifcounter")
    seqs = Biostrings::readDNAStringSet(seqfile)
    bg = readBackground(seqs, 0)
    #c+g=21
    #a+t=15
    correct = c(30, 56, 56, 30)
    expect_equal(bg@counts, c(30, 56, 56, 30))
    expect_true(all(bg@station == correct/172))
    
    # Check order-1 background for another toy sequence
    bg = readBackground(seqs, 1)
    
    #the correct number of observations
    
    expect_equal(bg@counts, c(8,  9,  9,  2,  9, 14, 18,  9,  9, 18, 14,  9,  2,  9,  9,  8))
    correct = matrix(c(8,  9,  9,  2,  9, 14, 18,  9,  9, 18, 14,  9,  2,  9,  9,  8), 4, 4)
    correct = correct / apply(correct, 1, sum)
    expect_that(all(t(matrix(bg@trans, 4, 4)) == correct), is_true())
    
})

#' Compound Poisson Approximation
#'
#' This function approximates the distribution of the number of motif hits
#' that emerges from a random DNA sequence of a given length.
#' 
#' The distribution can be determined in two alternative ways:
#' \enumerate{
#' \item A re-implemented version of the algorithm that was
#' described in Pape et al. \emph{Compound poisson approximation
#' of the number of occurrences of a position
#' frequency matrix (PFM) on both strands.} 2008
#' can be invoked using method='pape'.
#' The main purpose of this implementation concerns 
#' benchmarking an improved approximation.
#' In contrast to the original model, this implementation 
#' can be used with general order-d Markov models.
#' \item We provide an improved compound Poisson approximation that
#' uses more appropriate statistical assumptions concerning
#' overlapping motif hits and that can be used with order-d
#' background models as well. The improved version is used by default
#' with method='kopp'.
#' Note: Only method='kopp' supports the computation
#' of the distribution of the number of motif hits w.r.t. scanning
#' a single DNA strand (see \code{\link{probOverlapHit}}).
#' }
#'
#'
#' @param seqlen Integer-valued vector that defines the lengths of the
#' individual sequences. For a given DNAStringSet, 
#' this information can be retrieved using \code{\link{numMotifHits}}.
#' @param overlap An Overlap object.
#' @param method String that defines which method shall be invoked: 'pape' or
#' 'kopp' (see description). Default: method = 'kopp'.
#'
#' @return List containing
#' \describe{
#' \item{dist}{Distribution of the number of hits}
#' }
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#' 
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Load background model
#' bg = readBackground(seqs, 1)
#'
#' # Use 100 individual sequences of length 150 bp each
#' seqlen = rep(150, 100)
#'
#' # Compute overlapping probabilities
#' # for scanning the forward DNA strand only
#' op = motifcounter:::probOverlapHit(motif, bg, singlestranded = TRUE)
#'
#' # Computes  the compound Poisson distribution
#' dist = motifcounter:::compoundPoissonDist(seqlen, op)
#' #plot(1:length(dist$dist)-1, dist$dist)
#'
#' # Compute overlapping probabilities
#' # for scanning the forward DNA strand only
#' op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)
#' 
#' # Computes  the compound Poisson distribution
#' dist = motifcounter:::compoundPoissonDist(seqlen, op)
#' #plot(1:length(dist$dist)-1, dist$dist)
#'
#' @seealso \code{\link{combinatorialDist}}
#' @seealso \code{\link{probOverlapHit}}
#' @seealso \code{\link{numMotifHits}}
compoundPoissonDist = function(seqlen, overlap, method = "kopp") {
    stopifnot(is(overlap, "Overlap"))
    
    # Length must be at least as long as the motif
    sl = sum(vapply(seqlen, function(sl, ml) {
        sl - ml + 1
    }, FUN.VALUE = 0,
    ml = length(getBeta(overlap))))

    if (sl <= 0) {
        return (list(dist = 1))
    }
    
    # for all practical purposes, a maximal clump size of 60
    # should be enough
    maxclumpsize = 60
    
    # determine the max number of hits automatically from the
    # given sequence length.
    # even though it is a little bit of computational overhead,
    # set the maxhits to the total sequence length
    maxhits = sum(seqlen)
    dist = numeric(maxhits + 1)
    if (method == "kopp") {
        res = .C(
            motifcounter_compoundPoisson_useBeta,
            getAlpha(overlap),
            getBeta(overlap),
            getBeta3p(overlap),
            getBeta5p(overlap),
            as.numeric(dist),
            as.integer(length(seqlen)),
            as.integer(seqlen),
            as.integer(maxhits),
            as.integer(maxclumpsize),
            length(getBeta(overlap)),
            as.integer(getSinglestranded(overlap))
        )
        dist = res[[5]]
    } else if (method == "pape") {
        if (getSinglestranded(overlap) == TRUE) {
            stop(
                paste(strwrap(
                "method = 'pape' does not 
                support singlestranded = TRUE (see probOverlapHit).
                Please use method = 'kopp' instead."), collapse = "\n")
            )
        }
        res = .C(
            motifcounter_compoundPoissonPape_useGamma,
            getGamma(overlap),
            as.numeric(dist),
            as.integer(length(seqlen)),
            as.integer(seqlen),
            as.integer(maxhits),
            as.integer(maxclumpsize),
            length(getBeta(overlap))
        )
        dist = res[[2]]
        } else {
            stop(
                "Invalid 'method': The 'method' must be 'kopp' or 'pape'")
        }
    return (list(dist = dist))
}

#' Clump size distribution
#'
#' This function approximates the distribution of the clump sizes.
#' 
#' The clump size distribution can be determined in two alternative ways:
#' \enumerate{
#' \item A re-implemented version of the algorithm that was
#' described in Pape et al. \emph{Compound poisson approximation
#' of the number of occurrences of a position
#' frequency matrix (PFM) on both strands.} 2008
#' can be invoked using method='pape'.
#' \item An improved approximation of the clump size distribution 
#' uses more appropriate statistical assumptions concerning
#' overlapping motif hits and that can be used with order-d
#' background models as well. The improved version is used by default
#' with method='kopp'.
#' }
#'
#'
#' @inheritParams compoundPoissonDist
#' @param maxclump Maximal clump size
#'
#' @return List containing
#' \describe{
#' \item{dist}{Distribution of the clump size}
#' }
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#' 
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Load background model
#' bg = readBackground(seqs, 1)
#'
#' # Use 100 individual sequences of length 150 bp each
#' seqlen = rep(150, 100)
#'
#'
#' # Compute overlapping probabilities
#' # for scanning the forward DNA strand only
#' op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)
#' 
#' # Computes  the compound Poisson distribution
#' dist = motifcounter:::clumpSizeDist(20, op)
#'
#' @seealso \code{\link{probOverlapHit}}
clumpSizeDist = function(maxclump, overlap, method = "kopp") {
    stopifnot(is(overlap, "Overlap"))
    stopifnot(getSinglestranded(overlap) == FALSE)
    
    dist = numeric(maxclump)
    if (method == "kopp") {
        res = .C(
            motifcounter_clumpsize_kopp,
            getBeta(overlap),
            getBeta3p(overlap),
            getBeta5p(overlap),
            as.numeric(dist),
            as.integer(maxclump),
            length(getBeta(overlap))
        )
        dist = res[[4]]
    } else if (method == "pape") {
        res = .C(
            motifcounter_clumpsize_pape,
            getGamma(overlap),
            as.numeric(dist),
            as.integer(maxclump),
            length(getBeta(overlap))
        )
        dist = res[[2]]
    } else {
        stop(
            "Invalid 'method': The 'method' must be 'kopp' or 'pape'")
    }
    return (list(dist = dist))
}

context("Compound Poisson approx")

test_that("compoundPoissonDist", {
    # Initial settings
    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # Obtain background
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,1)

    for ( pwmname in c("x31.tab","x32.tab")) {

        # Read motifs
        motiffile=system.file("extdata",pwmname, package="motifcounter")
        motif=t(as.matrix(read.table(motiffile)))

        # Overlapping hit probs
        op=probOverlapHit(motif, bg,singlestranded=FALSE)

        # check short sequences
        expect_equal(compoundPoissonDist(0,op)$dist[1],1) # too short sequence
        expect_equal(compoundPoissonDist(-1,op)$dist[1],1) # too short sequence
        expect_equal(compoundPoissonDist(ncol(motif)-1,op)$dist[1],1) # too short sequence

        # check wrong method 
        expect_error(compoundPoissonDist(100, op, method=0))

        # check wrong overlap
        expect_error(compoundPoissonDist(100, 1, method="kopp"))

        # check if dist sums to one
        seqlen=rep(100,100)
        expect_equal(sum(compoundPoissonDist(seqlen, op, method="kopp")$dist),1)
        expect_equal(sum(compoundPoissonDist(seqlen, op,method="pape")$dist),1)
        
        # check if the mean is correct
        dist=compoundPoissonDist(seqlen, op, method="kopp")$dist
        expect_equal(sum(dist*seq(0,length(dist)-1)),
                     op@alpha*2*length(seqlen)*(seqlen[1]-ncol(motif)+1))

        # check for single stranded scanning
        op=probOverlapHit(motif, bg,singlestranded=TRUE)

        # pape not supported
        expect_error(compoundPoissonDist(seqlen, op,method="pape"))

        # check if dist sums to one
        dist=compoundPoissonDist(seqlen, op, method="kopp")$dist
        expect_equal(sum(dist),1)

        # check if the mean is correct
        expect_equal(sum(dist*seq(0,length(dist)-1)),
                     op@alpha*length(seqlen)*(seqlen[1]-ncol(motif)+1))
    }
    
    # Check combinatorial sequence length
})

test_that("jaspar motif tests", {
    # Check if mean and normalization is correct for a large
    # set of real motifs from jaspar
    library(MotifDb)
    motifs=as.list(query(query(MotifDb,"hsapiens"),"JASPAR_CORE"))

    #  init
    motifcounterOptions()

    # Obtain background
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,1)

    seqlen=10000

    for (motif in motifs) {
        # normalize motifs
        motif=normalizeMotif(motif,0.001)

        # check scanning both strands
        op=probOverlapHit(motif, bg,singlestranded=FALSE)
        dist=compoundPoissonDist(seqlen, op, method="kopp")$dist
        # normalization
        expect_equal(sum(dist),1)
        # check mean
        expect_equal(sum(dist*seq(0,length(dist)-1)),
                     op@alpha*2*length(seqlen)*(seqlen[1]-ncol(motif)+1))

        # check scanning a single strand
        op=probOverlapHit(motif, bg,singlestranded=TRUE)
        dist=compoundPoissonDist(seqlen, op, method="kopp")$dist
        # normalization
        expect_equal(sum(dist),1)
        # check mean
        expect_equal(sum(dist*seq(0,length(dist)-1)),
                     op@alpha*length(seqlen)*(seqlen[1]-ncol(motif)+1))
    }

})

test_that("clump size distribution", {
    #  init
    motifcounterOptions()

    # Obtain background
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,1)

    motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
    motif = t(as.matrix(read.table(motiffile)))
    maxclump = 20

    op = motifcounter:::probOverlapHit(motif, bg, singlestranded = TRUE)
    # single stranded not supported yet
    expect_error(motifcounter:::clumpSizeDist(maxclump, op))

    op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)

    # test kopp clump size corretness
    dist = motifcounter:::clumpSizeDist(maxclump, op)$dist
    expect_equal(length(dist), maxclump)
    expect_equal(sum(dist),1)

    # test pape clump size corretness
    dist = motifcounter:::clumpSizeDist(maxclump, op, method = "pape")$dist
    expect_equal(length(dist), maxclump)
    expect_equal(sum(dist),1)

    dist = motifcounter:::simulateClumpSizeDist(motif, bg, 1000000, nsim = 1)$dist
    expect_equal(sum(dist), 1)
})

#' TFBSs analysis in DNA sequences
#'
#' The package provides functions for determining the positions
#' of motif hits as well as motif hit
#' enrichment for a given position frequency matrix (PFM)
#' in a DNA sequence of interest.
#' The following examples guides you through the main 
#' functions of the `motifcounter` package. 
#' 
#' For an analysis with `motifcounter`,
#' the user is required to provide 1) a PFM,
#' 2) a DNA sequence which is used to estimate
#' a background model (see \code{link{readBackground}}),
#' 3) a DNA sequence of interest that shall be scanned for motif hits
#' (can be the same as the one used for point 2),
#' and 4) (optionally) a desired false positive probability of motif hits in
#' random DNA sequences (see \code{\link{motifcounterOptions}}).
#'
#'
#' \tabular{ll}{ Package: \tab motifcounter\cr
#' Type: \tab Package\cr Version: \tab
#' 1.0\cr Date: \tab 2016-11-04\cr License: \tab GPL-2\cr }
#'
#' @name motifcounter-package
#' @aliases motifcounter-package motifcounter
#' @docType package
#' @author Wolfgang Kopp
#'
#' Maintainer: Wolfgang Kopp <kopp@@molgen.mpg.de>
#' @keywords PFM, MotifEnrichment
#' @useDynLib motifcounter, .registration=TRUE
#' @import Biostrings
#' @import methods
#' @examples
#'
#' # Load sequences
#' file = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(file)
#' 
#' # Estimate an order-1 background model
#' order = 1
#' bg = readBackground(seqs, order)
#' 
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#' 
#' # Normalize the motif
#' # Normalization is sometimes necessary to prevent zeros in
#' # the motif
#' motif = normalizeMotif(motif)
#'
#' # Use subset of the sequences
#' seqs = seqs[1:10]
#'
#' # Optionally, set the false positive probability
#' #alpha=0.001 # is also the default
#' #motifcounterOptions(alpha) 
#'
#' # Investigate the per-position and per-strand scores in a given sequence
#' scores = scoreSequence(seqs[[1]], motif, bg)
#'
#' # Investigate the per-position and per-strand motif hits in a given sequence
#' hits = motifHits(seqs[[1]], motif, bg)
#'
#' # Determine the average score profile across a set of sequences
#' scores = scoreProfile(seqs, motif, bg)
#'
#' # Determine the average motif hit profile across a set of sequences
#' hits = motifHitProfile(seqs, motif, bg)
#'
#' # Determine the empirical score distribution
#' scoreHistogram(seqs, motif, bg)
#' 
#' # Determine the theoretical score distribution in random sequences
#' scoreDist(motif, bg)
#' 
#' 
#' # Determine the motif hit enrichment in a set of DNA sequences
#' # 1. Use the compound Poisson approximation
#' #    and scan only a single strand for motif hits
#' result = motifEnrichment(seqs, motif, bg,
#'             singlestranded = TRUE, method = "compound")
#'
#' # Determine the motif hit enrichment in a set of DNA sequences
#' # 2. Use the compound Poisson approximation
#' #    and scan both strands for motif hits
#' result = motifEnrichment(seqs, motif, bg,
#'             singlestranded = FALSE, method = "compound")
#'
#' # Determine the motif hit enrichment in a set of DNA sequences
#' # 3. Use the combinatorial model
#' #    and scan both strands for motif hits
#' result = motifEnrichment(seqs, motif, bg, singlestranded = FALSE,
#'             method = "combinatorial")
#' 
NULL

#' Generate DNAString
#'
#' This function generates a random DNAString of a given length
#' by sampling from the background model.
#'
#' @param len Integer length of the sequence
#' @template templates
#'
#' @return A DNAString object
#
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Generate a 1 kb random sequence
#' motifcounter:::generateDNAString(1000, bg)
#'
#' @seealso \code{\link{generateDNAStringSet}}
generateDNAString = function(len, bg) {
    len = as.integer(len)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    if (len < bg@order) {
        return(Biostrings::DNAString(""))
    }
    seq = paste(rep("N", len), collapse = "", sep = "")
    ret = .C(
        motifcounter_generateRndSeq,
        as.character(seq),
        as.integer(len),
        getStation(bg),
        getTrans(bg),
        as.integer(getOrder(bg))
    )
    return(Biostrings::DNAString(ret[[1]]))
}

#' Generate DNAStringSet
#'
#' This function generates a DNAStringSet-object of the
#' given individual sequence lengths
#' by sampling from the background model.
#'
#'
#' @inheritParams compoundPoissonDist
#' @template templates
#'
#' @return A DNAStringSet object
#
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Generate random sequences of various lengths
#' motifcounter:::generateDNAStringSet(10:50, bg)
#'
#' @seealso \code{\link{generateDNAStringSet}}
generateDNAStringSet = function(seqlen, bg) {
    stopifnot(is(bg, "Background"))
    validObject(bg)
    seqs = c()
    for (i in seq_len(length(seqlen))) {
        seqs = c(seqs, generateDNAString(seqlen[i], bg))
    }

    return(Biostrings::DNAStringSet(seqs))
}

#' Empirical number of motif hits distribution
#'
#' This function repeatedly simulates random DNA sequences according to
#' the background model and
#' subsequently counts how many motif hits occur in them.
#' Thus, this function gives rise to the empirical
#' distribution of the number of motif hits.
#' This function is only used for benchmarking analysis.
#'
#' @inheritParams numMotifHits
#' @inheritParams compoundPoissonDist
#' @param nsim Integer number of random samples.
#' @return A List that contains
#' \describe{
#' \item{dist}{Empirical distribution of the number of motif hits}
#' }
#' @examples
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Study the counts in one sequence of length 150 bp
#' seqlen = rep(150, 1)
#'
#' # Compute empirical distribution of the number of motif hits
#' # by scanning both strands using 100 samples
#' simc = motifcounter:::simulateNumHitsDist(motif, bg,
#'     seqlen, nsim = 100, singlestranded = FALSE)
#'
#' # Compute empirical distribution of the number of motif hits
#' # by scanning a single strand using 100 samples
#' simc = motifcounter:::simulateNumHitsDist(motif, bg,
#'     seqlen, nsim = 100, singlestranded = TRUE)
#'
#' @seealso \code{\link{compoundPoissonDist}},\code{\link{combinatorialDist}}
simulateNumHitsDist = function(pfm, bg, seqlen, nsim, singlestranded = FALSE) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)
    stopifnot(nsim > 0)

    freq = rep(0, 10)
    for (i in seq_len(nsim)) {
        seqs = generateDNAStringSet(seqlen, bg)
        nom = numMotifHits(seqs, pfm, bg, singlestranded)
        nom = sum(nom$numofhits)
        if (nom >= length(freq)) {
            #expand freq
            new_freq = rep(0, nom + 1)
            new_freq[1:length(freq)] = freq
            freq = new_freq
        }
        freq[nom + 1] = freq[nom + 1] + 1
    }
    freq = freq / sum(freq)
    return(list(dist = freq))
}

#' Empirical clump size distribution
#'
#' This function repeatedly simulates random DNA sequences according to
#' the background model and
#' subsequently counts the number of k-clump occurrences, where
#' denotes the clump size.
#' This function is only used for benchmarking analysis.
#'
#' @inheritParams numMotifHits
#' @inheritParams compoundPoissonDist
#' @param nsim Integer number of random samples.
#' @return A List that contains
#' \describe{
#' \item{dist}{Empirical distribution of the clump sizes}
#' }
#' @examples
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Study the clump size frequencies in one sequence of length 1 Mb
#' seqlen = 1000000
#'
#' # scan both strands
#' simc = motifcounter:::simulateClumpSizeDist(motif, bg, seqlen)
#'
#' # scan a single strand
#' simc = motifcounter:::simulateClumpSizeDist(motif, bg,
#'     seqlen, singlestranded = TRUE)
#'
#' @seealso \code{\link{compoundPoissonDist}},\code{\link{combinatorialDist}}
simulateClumpSizeDist = function(pfm, bg, seqlen, nsim=10, singlestranded = FALSE) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)
    stopifnot (length(seqlen) == 1)

    # 
    freq = rep(0, 5)
    for (p in seq_len(nsim)) {
        seq = generateDNAString(seqlen, bg)
        hits = motifHits(seq, pfm, bg)

        # determine the clump sizes
        if (singlestranded == TRUE) {
            h=hits$fhits
        } else {
            h=hits$fhits + hits$rhits
        }

        index_sequence = which(h>0)
        previous_index = index_sequence[1]
        cnt=h[previous_index]
        for (i in tail(seq_len(length(index_sequence)),-1)) {
            if (index_sequence[i] < previous_index+ncol(pfm)) {
                cnt = cnt + h[index_sequence[i]]
            } else {
                if (length(freq) < cnt) {
                    x = rep(0, cnt)
                    x[1:length(freq)] = freq
                    freq = x
                }
                freq[cnt] = freq[cnt] + 1
                cnt = h[index_sequence[i]]
            }
            previous_index = index_sequence[i]
        }
    }

    freq = freq / sum(freq)
    return(list(dist = freq))
}

#' Empirical score distribution
#'
#' This function estimates the empirical score distribution
#' on a set of randomly generated DNA sequences based on the
#' background model.
#' This function is only used for benchmarking analysis.
#'
#'
#' @inheritParams simulateNumHitsDist
#' @return List containing
#' \describe{
#' \item{scores}{Vector of scores}
#' \item{dist}{Score distribution}
#' }
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#'
#' # Compoute the empirical score distribution in
#' # sequences of length 1kb using 1000 samples
#' motifcounter:::scoreDistEmpirical(motif, bg, seqlen = 1000, nsim = 1000)
#'
#' @seealso \code{\link{scoreDist}}
scoreDistEmpirical = function(pfm, bg, seqlen, nsim) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)
    stopifnot(nsim > 0)
    if (seqlen < ncol(pfm)) {
        warning("seqlen shorter than ncol(pfm). Scores will always be zero.")
    }

    seqs = generateDNAStringSet(rep(seqlen, nsim), bg)
    sh = scoreHistogram(seqs, pfm, bg)

    probs = sh$dist / sum(sh$dist)
    return(list(scores = sh$score, dist = probs))
}

context("Simulation")

test_that("generateDNAString", {
    # Load background
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,1)

    # no background object
    expect_error(generateDNAString(1,1))

    # too short sequence
    expect_equal(length(generateDNAString(-1,bg)),0)
    expect_equal(length(generateDNAString(bg@order-1,bg)),0)

    # Normal sequence
    expect_equal(length(generateDNAString(10,bg)),10)
})

test_that("generateDNAStringSet", {
    # Load background
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,1)

    # no background object
    expect_error(generateDNAStringSet(1,1))

    # too short sequence
    #expect_warning(generateDNAStringSet(-1,bg))
    #expect_warning(generateDNAStringSet(bg$order-1,bg))
    expect_equal(length(generateDNAStringSet(-1,bg)[[1]]),0)
    expect_equal(
        length(generateDNAStringSet(bg@order-1,bg)[[1]]),0)

    # Normal sequences
    expect_equal(length(generateDNAStringSet(10,bg)),1)
    expect_equal(length(generateDNAStringSet(rep(10,10),bg)),10)
})

test_that("simulateNumHitsDist", {
    # Load sequences
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs,1)

    # Load motif
    motiffile=system.file("extdata","x31.tab",package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    for (ss in c(TRUE,FALSE)) {
        # normal set of sequences
        ret=simulateNumHitsDist(motif,bg,rep(10,10),nsim=100,singlestranded=ss)
        expect_equal(sum(ret$dist),1)

        # one sequence
        ret=simulateNumHitsDist(motif,bg,10,nsim=100,singlestranded=ss)
        expect_equal(sum(ret$dist),1)

        # too short sequences
        ret=simulateNumHitsDist(motif,bg,0,nsim=100,singlestranded=ss)
        expect_equal(sum(ret$dist),1)
        expect_equal(ret$dist[1],1)

        # too short sequences
        ret=simulateNumHitsDist(motif,bg,ncol(motif)-1,
                                nsim=100,singlestranded=ss)
        expect_equal(sum(ret$dist),1)
        expect_equal(ret$dist[1],1)
    }
    
    # test short sequences
    expect_error(simulateNumHitsDist(motif,bg,rep(10,10),nsim=0))
    expect_error(simulateNumHitsDist(motif,bg,rep(10,10),nsim=-1))
})

test_that("scoreDistEmpirical", {
    # Load sequences
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs,1)
    generateDNAString(100,bg) # after background loading everything should work

    # Load motif
    motiffile=system.file("extdata","x31.tab",package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # test if it sums to one
    expect_equal(sum(scoreDistEmpirical(motif,bg,100,10)[[2]]),1)
    expect_equal(length(scoreDistEmpirical(motif,bg,100,10)[[2]]),
                 length(scoreDistEmpirical(motif,bg,100,10)[[1]]))
    expect_equal(sum(scoreDistEmpirical(motif,bg,ncol(motif),10)[[2]]),1)

    # Check too short sequence
    expect_warning({
        expect_true(is.na(sum(scoreDistEmpirical(motif,bg,0,10)[[2]])))
    })
    expect_warning({
        expect_true(is.na(sum(
            scoreDistEmpirical(motif,bg,ncol(motif)-1,10)[[2]])))
    })

    #expect warning due to short sequence length
    expect_warning(scoreDistEmpirical(motif,bg,0,10))
    expect_warning(scoreDistEmpirical(motif,bg,ncol(motif)-1,10))
})

#' Motif hit observations
#'
#' This function determines per-position motif hits in a given DNA sequence.
#' @include score_wrapper.R
#' @inheritParams scoreSequence
#' @param threshold Score threshold for calling motif matches. If NULL,
#' the threshold will determined from alpha.
#' @return List containing
#' \describe{
#' \item{fhits}{Per-position motif hits on the forward strand}
#' \item{rhits}{Per-position motif hits on the reverse strand}
#' }
#'
#' @examples
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seq = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seq, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Determine the motif hits
#' motifHits(seq[[1]], motif, bg)
#'
#' @export
motifHits = function(seq, pfm, bg, threshold=NULL) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)

    if (is.null(threshold)) {
      threshold = scoreThreshold(pfm, bg)$threshold
    }

    fhits = hitStrand(seq, pfm, bg, threshold)
    rhits = hitStrand(seq, revcompMotif(pfm), bg, threshold)

    return(list(fhits = fhits, rhits = rhits))
}

#' Hit strand
#'
#' This function computes the per-position
#' motif matches in a given DNA strand.
#'
#' The function returns the per-position scores
#' for the given strand. If the sequence is too short,
#' it contains an empty vector.
#'
#' @inheritParams motifHits
#' @return
#' \describe{
#' \item{hits}{Vector of motif hits on the given strand}
#' }
#'
#' @examples
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the per-position and per-strand scores
#' motifcounter:::hitStrand(seqs[[1]], motif, bg)
#'
hitStrand = function(seq, pfm, bg, threshold=NULL) {
  motifValid(pfm)
  stopifnot(is(bg, "Background"))
  validObject(bg)
  motifAndBackgroundValid(pfm, bg)

  # Check class
  stopifnot(is(seq, "DNAString"))

  if (is.null(threshold)) {
    threshold = scoreThreshold(pfm, bg)$threshold
  }

  hits = .Call(
    motifcounter_hitsequence,
    as.numeric(pfm),
    nrow(pfm),
    ncol(pfm),
    toString(seq),
    getStation(bg),
    getTrans(bg),
    as.integer(getOrder(bg)),
    as.numeric(threshold)
  )
  return(as.numeric(hits))
}


#' Motif hit profile across multiple sequences
#'
#' This function computes the per-position average motif hit
#' profile across a set of fixed-length DNA sequences.
#' It can be used to reveal positional constraints
#' of TFBSs.
#'
#' @inheritParams scoreProfile
#'
#' @return List containing
#' \describe{
#' \item{fscores}{Per-position average forward strand motif hits}
#' \item{rscores}{Per-position average reverse strand motif hits}
#' }
#'
#' @examples
#'
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#' seqs = seqs[1:10]
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the motif hit profile
#' motifHitProfile(seqs, motif, bg)
#'
#' @export
motifHitProfile = function(seqs, pfm, bg) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)

    if (is(seqs, "DNAString")) {
      # wrap the sequence up as sequence set
      seqs = DNAStringSet(seqs)
    }

    stopifnot(is(seqs,"DNAStringSet"))

    sth = scoreThreshold(pfm, bg)

    if (any(lenSequences(seqs) != lenSequences(seqs)[1])) {
        stop(paste(strwrap("All DNAStrings in 'seqs' must be of equal length.
            Please trim the sequences such that they are equally long."),
            collapse = "\n"))
    }
    slen = lenSequences(seqs[1])
    if (slen <= ncol(pfm) - 1) {
        return (list(fhits = numeric(0), rhits = numeric(0)))
    }

    fhits = vapply(seqs, function(seq, pfm, bg, th) {
        return(motifHits(seq, pfm, bg, th)$fhits)
    }, FUN.VALUE = numeric(slen - ncol(pfm) + 1), pfm, bg,
    sth$threshold)

    fhits = rowMeans(as.matrix(fhits), na.rm = TRUE)

    rhits = vapply(seqs, function(seq, pfm, bg, th) {
        mh = motifHits(seq, pfm, bg, th)$rhits
    }, FUN.VALUE = numeric(slen - ncol(pfm) + 1), pfm, bg,
    sth$threshold)

    rhits = rowMeans(as.matrix(rhits), na.rm = TRUE)
    return (list(fhits = as.vector(fhits), rhits = as.vector(rhits)))
}

#' Number of motif hits in a set of DNA sequences
#'
#' This function counts the number of motif hits that
#' are found in a given set of DNA sequences.
#'
#' Optionally, it can be used to count motif hits on
#' one or both strands, respectively.
#'
#'
#' @inheritParams scoreProfile
#' @param singlestranded Boolean that indicates whether a single strand or
#' both strands shall be scanned for motif hits.
#' Default: singlestranded = FALSE.
#' @return A list containing
#' \describe{
#' \item{nseq}{Number of individual sequences}
#' \item{lseq}{Vector of individual sequence lengths}
#' \item{numofhits}{Vector of the number of hits in each individual sequence}
#' }
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Count motif hits both strands
#' noc = motifcounter:::numMotifHits(seqs, motif, bg)
#' noc$numofhits
#'
#' # Count motif hits on a single strand
#' noc = motifcounter:::numMotifHits(seqs, motif, bg, singlestranded = TRUE)
#' noc$numofhits
#'
numMotifHits = function(seqs, pfm, bg, singlestranded = FALSE) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)

    if (is(seqs, "DNAString")) {
      # wrap the sequence up as sequence set
      seqs = DNAStringSet(seqs)
    }

    stopifnot(is(seqs, "DNAStringSet"))

    sth = scoreThreshold(pfm, bg)

    # retrieve the number of motif hits
    noh = vapply(seqs, function(seq, pfm, bg, singlestranded, th) {
        ret = motifHits(seq, pfm, bg, th)
        if (singlestranded == FALSE) {
            return(sum(ret[[1]] + ret[[2]], na.rm = FALSE))
        } else {
            return(sum(ret[[1]], na.rm = FALSE))
        }
    }, numeric(1), pfm, bg, singlestranded, sth$threshold)

    lseq = lenSequences(seqs)

    nseq = length(seqs)

    return (list(
        nseq = nseq,
        lseq = lseq,
        numofhits = noh
    ))
}

context("Count")
library(MotifDb)

test_that("oct4_vignette_example_alpha0001", {
  library(MotifDb)
  alpha=0.001
  gran=0.1
  motifcounterOptions(alpha, gran)

  order <- 1
  file <- system.file("extdata", "seq.fasta", package = "motifcounter")
  seqs <- Biostrings::readDNAStringSet(file)
  bg <- readBackground(seqs, order)

  file <- system.file("extdata", "oct4_chipseq.fa", package = "motifcounter")
  oct4peaks <- Biostrings::readDNAStringSet(file)

  oct4 <- as.list(query(query(query(MotifDb, "hsapiens"),
                              "pou5f1"), "jolma2013"))[[1]]
  motif <- oct4

  mhits <- motifHits(oct4peaks[[1]], motif, bg)

  # Inspect the result
  fhitpos <- which(mhits$fhits == 1)
  rhitpos <- which(mhits$rhits == 1)
  expect_equal(length(fhitpos), 0)
  expect_equal(length(rhitpos), 1)
  expect_equal(rhitpos, 94)

})

test_that("oct4_vignette_example_alpha001", {
  library(MotifDb)
  alpha=0.01
  gran=0.1
  motifcounterOptions(alpha, gran)

  order <- 1
  file <- system.file("extdata", "seq.fasta", package = "motifcounter")
  seqs <- Biostrings::readDNAStringSet(file)
  bg <- readBackground(seqs, order)

  file <- system.file("extdata", "oct4_chipseq.fa", package = "motifcounter")
  oct4peaks <- Biostrings::readDNAStringSet(file)

  oct4 <- as.list(query(query(query(MotifDb, "hsapiens"),
                              "pou5f1"), "jolma2013"))[[1]]
  motif <- oct4

  mhits <- motifHits(oct4peaks[[1]], motif, bg)

  # Inspect the result
  fhitpos <- which(mhits$fhits == 1)
  rhitpos <- which(mhits$rhits == 1)
  expect_equal(length(fhitpos), 4)
  expect_equal(length(rhitpos), 4)
  expect_equal(fhitpos, c(54, 87, 93, 112))
  expect_equal(rhitpos, c(55, 94, 111, 118))

})

test_that("motifHits", {
    # init
    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # load sequences
    seqfile=system.file("extdata","test2.fa", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs,1)

    # Load motif
    name="x3.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))


    # Check too short sequence
    expect_equal(length(motifHits(Biostrings::DNAString(""),motif,bg)[[1]]),0)
    expect_equal(length(motifHits(Biostrings::DNAString(""),motif,bg)[[2]]),0)
    expect_equal(length(motifHits(generateDNAString(ncol(motif)-1,bg),motif,bg)[[1]]),0)
    expect_equal(length(motifHits(generateDNAString(ncol(motif)-1,bg),motif,bg)[[2]]),0)

    # check motif shorter than bg order
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs,2)
    expect_error(motifHits(seqs,as.matrix(motif[, 1]),bg)[[1]])

    # Reload background
    seqfile=system.file("extdata","test2.fa", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)
    # only use the first two sequences without N's to retain the current testing behaviour
    bg=readBackground(seqs[1:2],1)

    # Test correct hit positions
    mh=motifHits(seqs[[1]], motif,bg)
    # because it is a palindrome
    expect_equal(mh[[1]],mh[[2]])
    # there must be a hit at position 13
    x=rep(0,20)
    x[13]=1
    expect_equal(mh[[1]],x)

    # no hit in the second sequence
    mh=motifHits(seqs[[2]], motif,bg)
    expect_equal(mh[[1]],mh[[2]])
    x=rep(0,length(seqs[[2]])-ncol(motif)+1)
    expect_equal(mh[[1]],x)

    # zero length sequence, due to 'N'
    mh=motifHits(seqs[[3]], motif,bg)
    expect_equal(c(length(mh[[1]]),length(mh[[2]])),c(10,10))
    expect_equal(mh$fhits, c(0, NaN, NaN, NaN, NaN, NaN, NaN, 0, 0, 0))

    # Check with aaa repeat motif
    name="x8.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))

    mh=motifHits(seqs[[2]],motif,bg)
    x=rep(0,length(seqs[[2]])-ncol(motif)+1)
    # in the reverse strand no hit
    expect_equal(mh[[2]],x)
    x[4]=1
    # in the forward strand one hit
    expect_equal(mh[[1]],x)

})

test_that("motifHitProfile", {
    # init
    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # Load seqs
    seqfile=system.file("extdata","test2.fa", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load Background
    bg=readBackground(seqs[1:2],1)

    # palindrom
    name="x3.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))

    # error because it is no DNAStringSet
    # This was updated. It used to only accept DNAStringSet,
    # but now, DNAStringSet and DNAString is accepted.
    motifHitProfile(seqs[[1]],motif,bg)

    # error because unequal sequence length
    expect_error(motifHitProfile(seqs[1:2],motif,bg))

    # Check too short sequence
    expect_equal(length(motifHitProfile(Biostrings::DNAStringSet(""),
                                        motif,bg)$fhits),0)
    expect_equal(length(motifHitProfile(generateDNAStringSet(ncol(motif)-1,bg),
                                 motif,bg)$fhits),0)

    # check motif shorter than bg order
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs2=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs2,2)
    expect_error(motifHitProfile(seqs,as.matrix(motif[, 1]),bg)[[1]])

    # Reload background
    bg=readBackground(seqs[1:2],1)

    # Test correct hit positions
    mh=motifHitProfile(seqs[1], motif,bg)
    # because it is a palindrome
    expect_equal(mh[[1]],mh[[2]])
    # there must be a hit at position 13
    x=rep(0,20)
    x[13]=1
    expect_equal(mh[[1]],x)

    # no hit in the second sequence
    mh=motifHitProfile(seqs[2], motif,bg)
    expect_equal(mh[[1]],mh[[2]])
    x=rep(0,length(seqs[[2]])-ncol(motif)+1)
    expect_equal(mh[[1]],x)

    # zero length sequence, due to 'N'
    mh=motifHitProfile(seqs[3], motif,bg)
    expect_equal(c(length(mh[[1]]),length(mh[[2]])),c(10,10))
    expect_equal(mh$fhits, c(0, NaN, NaN, NaN, NaN, NaN, NaN, 0, 0, 0))

    seqs2=seqs
    seqs2[[1]] = seqs2[[1]][1:10]
    seqs2[[3]] = seqs2[[3]][1:10]
    mh=motifHitProfile(seqs2, motif,bg)

    # Check with aaa repeat motif
    name="x8.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))


    profile=motifHitProfile(seqs[2],motif,bg)
    x=rep(0,length(seqs[[2]])-ncol(motif)+1)
    # in the reverse strand no hit
    expect_equal(profile[[2]],x)
    x[4]=1
    # in the forward strand one hit
    expect_equal(profile[[1]],x)

})

test_that("numMotifHits", {
    # init
    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # Load seqs
    seqfile=system.file("extdata","test2.fa", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load Background
    bg=readBackground(seqs[1:2],1)

    # palindrom
    name="x3.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))


    # no DNAString
    expect_error(numMotifHits(seqfile,motif,bg,singlestranded=TRUE))
    expect_error(numMotifHits(seq[[1]],motif,bg,singlestranded=TRUE))

    # Check short DNA sequence
    for (ss in c(TRUE, FALSE)) {

        expect_equal(numMotifHits(Biostrings::DNAStringSet(""),motif,bg)[[1]],1)
        expect_equal(numMotifHits(Biostrings::DNAStringSet(""),motif,bg)[[2]],0)
        expect_equal(numMotifHits(Biostrings::DNAStringSet(""),motif,bg)[[3]],0)
        expect_equal(numMotifHits(
                generateDNAStringSet(ncol(motif)-1,bg),motif,bg)[[1]],1)
        expect_equal(numMotifHits(
                generateDNAStringSet(ncol(motif)-1,bg),motif,bg)[[2]],ncol(motif)-1)
        expect_equal(numMotifHits(
                generateDNAStringSet(ncol(motif)-1,bg),motif,bg)[[3]],0)
    }



    # test with palindromic motif
    name="x3.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))

    # there is a hit in the first sequence
    nom=numMotifHits(seqs,motif,bg,singlestranded=TRUE)
    expect_equal(nom$nseq,3)
    expect_equal(as.vector(nom$lseq),c(23,10,13))
    expect_equal(as.vector(nom$numofhits),c(1,0,NaN))

    nom=numMotifHits(seqs,motif,bg,singlestranded=FALSE)
    expect_equal(nom$nseq,3)
    expect_equal(as.vector(nom$lseq),c(23,10,13))
    expect_equal(as.vector(nom$numofhits),c(2,0,NaN))


    # test with repeat motif
    name="x8.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))

    # there is a hit in the second sequence
    nom=numMotifHits(seqs,motif,bg,singlestranded=TRUE)
    expect_equal(nom$nseq,3)
    expect_equal(as.vector(nom$lseq),c(23,10,13))
    expect_equal(as.vector(nom$numofhits),c(0,1,NaN))

    nom=numMotifHits(seqs,motif,bg,singlestranded=FALSE)
    expect_equal(nom$nseq,3)
    expect_equal(as.vector(nom$lseq),c(23,10,13))
    expect_equal(as.vector(nom$numofhits),c(0,1,NaN))

})

#' Length of sequences in a given fasta file
#'
#' The function returns a vector containing the lengths
#' of each sequence contained in a set of sequences. Sequences
#' containing 'N' or 'n' are skipped from the analysis and are
#' set to length zero.
#'
#' @param seqs A DNAStringSet or DNAString object
#' @return A vector containing the lengths of each individual sequences
#'
#' @examples
#'
#' # Load sequences
#' file = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(file)
#'
#' # Retrieve sequence lengths
#' motifcounter:::lenSequences(seqs)
#'
lenSequences = function(seqs) {

    if (is(seqs, "DNAString")) {
        # wrap the sequence up as sequence set
        seqs = DNAStringSet(seqs)
    }
    
    stopifnot(is(seqs, "DNAStringSet"))

    lseq = vapply(seqs, function(seq) {
        return(.Call(motifcounter_slen, toString(seq)))
    }, FUN.VALUE = integer(1))

    return(as.vector(lseq))
}

context("Observation")

test_that("lenSequences", {
    expect_error(lenSequences(3)) # wrong class

    # check sequence length
    seqs=Biostrings::DNAStringSet(c("aaa","aNa","aR"))
    expect_equal(lenSequences(seqs),c(3,3,2))
})

#' Enrichment of motif hits
#'
#' This function determines whether a given motif is enriched in a given
#' DNA sequences. 
#' 
#' Enrichment is tested by comparing the observed 
#' number of motif hits against a theoretical distribution of the number
#' of motif hits in random DNA sequences.
#' Optionally, the theoretical distribution of the number of motif
#' hits can be evaluated by either a 'compound Poisson model' 
#' or the 'combinatorial model'.
#' Additionally, the enrichment test can be conducted with respect
#' to scanning only the forward strand or both strands of the DNA
#' sequences. The latter option is only available for the
#' 'compound Poisson model'
#' @include count_wrapper.R
#'
#' @inheritParams numMotifHits
#' @param method String that defines whether to use
#' the 'compound' Poisson approximation' or the 'combinatorial' model.
#' Default: method='compound'.
#'
#' @return List that contains
#' \describe{
#' \item{pvalue}{P-value for the enrichment test}
#' \item{fold}{Fold-enrichment with respect to the expected number of hits}
#' }
#' @examples
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#' 
#' # Load background
#' bg = readBackground(seqs, 1)
#' 
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # 1 ) Motif enrichment test w.r.t. scanning a *single* DNA strand
#' # based on the 'Compound Poisson model'
#' 
#' result = motifEnrichment(seqs, motif, bg,
#'             singlestranded = TRUE, method = "compound")
#'
#' # 2 ) Motif enrichment test w.r.t. scanning *both* DNA strand
#' # based on the 'Compound Poisson model'
#' 
#' result = motifEnrichment(seqs, motif, bg, method = "compound")
#'
#' # 3 ) Motif enrichment test w.r.t. scanning *both* DNA strand
#' # based on the *combinatorial model*
#'
#' result = motifEnrichment(seqs, motif, bg, singlestranded = FALSE,
#'             method = "combinatorial")
#'
#' @seealso \code{\link{compoundPoissonDist}}, \code{\link{combinatorialDist}}
#' @export
motifEnrichment = function(seqs, pfm, bg, singlestranded = FALSE, 
                            method = "compound") {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)

    #compute overlapping hit probs
    overlap = probOverlapHit(pfm, bg, singlestranded)

    # detemine the number of motif hits
    observations = numMotifHits(seqs, pfm, bg, singlestranded)
    if (is.nan(sum(observations$numofhits))) {
      stop("Number of motif hits is NaN. This is likely due to N's in the sequence.
           Please remove sequence containing N's.")
    }
    if (method == "compound") {
        dist = compoundPoissonDist(observations$lseq, overlap)
    } else if (method == "combinatorial") {
        dist = combinatorialDist(observations$lseq, overlap)
    } else {
        stop("Invalid method: 'method' must be 'compound' or 'combinatorial'")
    }
    ind = seq_len(length(dist$dist))
    ind = ind[ind >= (sum(observations$numofhits) + 1)]
    p = sum(dist$dist[ind])

    return (list(
        pvalue = p,
        fold = sum(observations$numofhits) /
            sum(dist$dist * seq(0, length(dist$dist) - 1))
    ))
}

#' Score distribution
#'
#' This function computes the score distribution for the given PFM and
#' background. The Score distribution is computed based on an efficient
#' dynamic programming algorithm.
#'
#' @inheritParams motifValid
#' @template templates
#' @return List that contains
#' \describe{
#' \item{scores}{Vector of scores}
#' \item{dist}{Score distribution}
#' }
#'
#' @examples
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the score distribution
#' dp = scoreDist(motif, bg)
#'
#' @export
scoreDist = function(pfm, bg) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)

    scores = .Call(
        motifcounter_scorerange,
        as.numeric(pfm),
        nrow(pfm),
        ncol(pfm),
        getStation(bg),
        getTrans(bg),
        as.integer(getOrder(bg))
    )

    dist = .Call(
        motifcounter_scoredist,
        as.numeric(pfm),
        nrow(pfm),
        ncol(pfm),
        getStation(bg),
        getTrans(bg),
        as.integer(getOrder(bg))
    )
    return(list(scores = scores, dist = dist))
}


#' Score distribution
#'
#' This function computes the score distribution for a given PFM and
#' a background model.
#'
#' The result of this function is identical to \code{\link{scoreDist}},
#' however, the method employs a less efficient algorithm that
#' enumerates all DNA sequences of the length of the motif.
#' This function is only used for debugging and testing purposes
#' and might require substantial computational
#' resources for long motifs.
#'
#' @inheritParams scoreDist
#' @return List containing
#' \describe{
#' \item{scores}{Vector of scores}
#' \item{dist}{Score distribution}
#' }
#'
#' @seealso \code{\link{scoreDist}}
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the score distribution
#' dp = motifcounter:::scoreDistBf(motif, bg)
#'
scoreDistBf = function(pfm, bg) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)

    scores = .Call(
        motifcounter_scorerange,
        as.numeric(pfm),
        nrow(pfm),
        ncol(pfm),
        getStation(bg),
        getTrans(bg),
        as.integer(getOrder(bg))
    )

    dist = .Call(
        motifcounter_scoredist_bf,
        as.numeric(pfm),
        nrow(pfm),
        ncol(pfm),
        getStation(bg),
        getTrans(bg),
        as.integer(getOrder(bg))
    )
    return(list(scores = scores, dist = dist))
}

#' Score strand
#'
#' This function computes the per-position
#' score in a given DNA strand.
#'
#' The function returns the per-position scores
#' for the given strand. If the sequence is too short,
#' it contains an empty vector.
#'
#' @inheritParams scoreDist
#' @param seq A DNAString object
#' @return
#' \describe{
#' \item{scores}{Vector of scores on the given strand}
#' }
#'
#' @examples
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the per-position and per-strand scores
#' motifcounter:::scoreStrand(seqs[[1]], motif, bg)
#'
scoreStrand = function(seq, pfm, bg) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)

    # Check class
    stopifnot(is(seq, "DNAString"))

    scores = .Call(
        motifcounter_scoresequence,
        as.numeric(pfm),
        nrow(pfm),
        ncol(pfm),
        toString(seq),
        getStation(bg),
        getTrans(bg),
        as.integer(getOrder(bg))
    )
    return(as.numeric(scores))
}

#' Score observations
#'
#' This function computes the per-position and per-strand
#' score in a given DNA sequence.
#'
#' @inheritParams scoreDist
#' @param seq A DNAString object
#' @return List containing
#' \describe{
#' \item{fscores}{Vector of scores on the forward strand}
#' \item{rscores}{Vector of scores on the reverse strand}
#' }
#'
#' @examples
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the per-position and per-strand scores
#' scoreSequence(seqs[[1]], motif, bg)
#'
#' @export
scoreSequence = function(seq, pfm, bg) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    motifAndBackgroundValid(pfm, bg)

    # Check class
    stopifnot(is(seq, "DNAString"))

    fscores = scoreStrand(seq, pfm, bg)
    rscores = scoreStrand(seq, revcompMotif(pfm), bg)
    return(list(fscores = fscores, rscores = rscores))
}

#' Score profile across multiple sequences
#'
#' This function computes the per-position and per-strand
#' average score profiles across a set of DNA sequences.
#' It can be used to reveal positional constraints
#' of TFBSs.
#'
#' @inheritParams scoreDist
#' @param seqs A DNAStringSet or DNAString object
#'
#' @return List containing
#' \describe{
#' \item{fscores}{Vector of per-position average forward strand scores}
#' \item{rscores}{Vector of per-position average reverse strand scores}
#' }
#'
#' @examples
#'
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the score profile
#' scoreProfile(seqs, motif, bg)
#'
#' @export
scoreProfile = function(seqs, pfm, bg) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)

    if (is(seqs, "DNAString")) {
        # wrap the sequence up as sequence set
        seqs = DNAStringSet(seqs)
    }

    stopifnot (is(seqs, "DNAStringSet"))

    if (any(lenSequences(seqs) != lenSequences(seqs)[1])) {
        stop(paste(strwrap("All DNAStrings in 'seqs' must be of equal length
            and must not contain 'N's. Please remove sequences that contain
            'N's from 'seqs' and/or trim
            trim the sequences such that they are equally long."),
            collapse = "\n"))
    }
    slen = lenSequences(seqs[1])

    if (slen <= ncol(pfm) - 1) {
        return (list(fscores = integer(0), rscores = integer(0)))
    }

    fscores = vapply(seqs, function(seq, pfm, bg) {
        s = scoreStrand(seq, pfm, bg)
    },
    FUN.VALUE = numeric(slen - ncol(pfm) + 1),
    pfm, bg)
    fscores = rowMeans(as.matrix(fscores))

    rscores = vapply(seqs, function(seq, pfm, bg) {
        s = scoreStrand(seq, revcompMotif(pfm), bg)
    },
    FUN.VALUE = numeric(slen - ncol(pfm) + 1),
    pfm, bg)
    rscores = rowMeans(as.matrix(rscores), na.rm = TRUE)
    return (list(
        fscores = as.vector(fscores),
        rscores = as.vector(rscores)
    ))
}

#' Score histogram on a single sequence
#'
#' This function computes the empirical score
#' distribution by normalizing the observed score histogram
#' for a given sequence.
#'
#'
#' @inheritParams scoreSequence
#' @return List containing
#' \describe{
#' \item{scores}{Vector of scores}
#' \item{dist}{Score distribution}
#' }
#'
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the per-position and per-strand scores
#' motifcounter:::scoreHistogramSingleSeq(seqs[[1]], motif, bg)
#'
scoreHistogramSingleSeq = function(seq, pfm, bg) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)
    stopifnot(is(seq, "DNAString"))
    motifAndBackgroundValid(pfm, bg)

    scores = .Call(
        motifcounter_scorerange,
        as.numeric(pfm),
        nrow(pfm),
        ncol(pfm),
        getStation(bg),
        getTrans(bg),
        as.integer(getOrder(bg))
    )

    dist = .Call(
        motifcounter_scorehistogram,
        as.numeric(pfm),
        nrow(pfm),
        ncol(pfm),
        toString(seq),
        getStation(bg),
        getTrans(bg),
        as.integer(getOrder(bg))
    )
    result = list(scores = scores, dist = dist)

    return(result)
}


#' Score histogram
#'
#' This function computes the empirical score
#' distribution for a given set of DNA sequences.
#'
#' It can be used to compare the empirical score
#' distribution against the theoretical one (see \code{\link{scoreDist}}).
#'
#' @inheritParams scoreProfile
#' @return List containing
#' \describe{
#' \item{scores}{Vector of scores}
#' \item{dist}{Score distribution}
#' }
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the empirical score histogram
#' scoreHistogram(seqs, motif, bg)
#'
#' @seealso \code{\link{scoreDist}}
#' @export
scoreHistogram = function(seqs, pfm, bg) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)

    if (is(seqs, "DNAString")) {
        # wrap the sequence up as sequence set
        seqs = DNAStringSet(seqs)
    }

    stopifnot(is(seqs, "DNAStringSet"))

    # First, extract the score range
    his = lapply(seqs[1], scoreHistogramSingleSeq, pfm, bg)
    nseq = length(his)
    scores = his[[1]]$scores

    # Then extract the histogram
    his = vapply(seqs, function(seq, pfm, bg) {
        scoreHistogramSingleSeq(seq, pfm, bg)$dist
    }, FUN.VALUE = numeric(length(scores)), pfm, bg)

    freq = rowSums(his)
    result = list(scores = scores, dist = freq)

    return(result)
}

#' Score threshold
#'
#' This function computes the score threshold for a desired
#' false positive probability `alpha`.
#'
#' Note that the returned alpha usually differs slightly
#' from the one that is prescribed using
#' \code{\link{motifcounterOptions}}, because
#' of the discrete nature of the sequences.
#'
#' @inheritParams scoreDist
#' @return List containing
#' \describe{
#' \item{threshold}{Score threshold}
#' \item{alpha}{False positive probability}
#' }
#' @examples
#'
#' # Load sequences
#' seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
#' seqs = Biostrings::readDNAStringSet(seqfile)
#'
#' # Load background
#' bg = readBackground(seqs, 1)
#'
#' # Load motif
#' motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
#' motif = t(as.matrix(read.table(motiffile)))
#'
#' # Compute the score threshold
#' motifcounter:::scoreThreshold(motif, bg)
#'
scoreThreshold = function(pfm, bg) {
    motifValid(pfm)
    stopifnot(is(bg, "Background"))
    validObject(bg)

    scoredist = scoreDist(pfm, bg)

    # find quantile
    ind = which(1 - cumsum(scoredist$dist) <= sigLevel())
    if (length(ind) <= 1) {
        stop(paste(strwrap(
            "The significance level 'alpha' is too stringent
            for the given 'pfm'. Motif matches are impossible.
            Increase 'alpha' using 'motifcounterOptions()'."), collapse = "\n"))
    }
    ind = tail(ind, -1)
    alpha = sum(scoredist$dist[ind])

    ind = min(ind)
    threshold = scoredist$scores[ind]

    return(list(threshold = threshold, alpha = alpha))
}

context("Score distribution")

test_that("scoreDists", {
    # in this part we test scoreDist, scoreDistBf and scoreDistEmpirical

    alpha=0.01
    motifcounterOptions(alpha)

    # Load sequences
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs, 0)

    # Load motif
    motifname="x1.tab"
    motiffile=system.file("extdata",motifname, package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # Check motif shorter than background order
    bg=readBackground(seqs, 2)
    expect_error(scoreDist(as.matrix(motif[,1]),bg))

    # Reinit background
    bg=readBackground(seqs, 0)

    # 1. test: with motif of length one
    # compute the score distribution for this case in R
    s=round((log(motif[,1])-log(bg@station))*10)
    srange=seq(min(s),max(s))
    p=rep(0,length(srange))
    for (i in 1:length(srange)){
        p[i]=sum(bg@station[which(s==srange[i])])
    }

    dp=scoreDist(as.matrix(motif[,1]),bg)

    # test for equality of the two variants
    expect_equal(sum(dp[[2]]),1)
    expect_equal(length(srange),length(dp[[1]]))
    expect_equal(srange,round(dp[[1]]*10))
    expect_equal(p,dp[[2]])


    # test with the stationary probabilities of the background model only
    for (m in seq(0,3)) {
        bg=readBackground(seqs, m)

        if (m==0) {
            #simluate score distribution
            sims=scoreDistEmpirical(as.matrix(motif[,1]), bg,1,1000)
            #compute exact score distribution
            dp=scoreDist(as.matrix(motif[,1]),bg)
            bf=scoreDistBf(as.matrix(motif[,1]),bg)

        } else {
            #simluate score distribution
            sims=scoreDistEmpirical(as.matrix(motif[,1:m]),bg,m,1000)
            #compute exact score distribution
            dp=scoreDist(as.matrix(motif[,1:m]),bg)
            bf=scoreDistBf(as.matrix(motif[,1:m]),bg)
        }

        expect_equal(sum(dp[[2]]),1)
        expect_equal(bf[[1]],dp[[1]])
        expect_equal(bf[[2]],dp[[2]])
        expect_equal(sims[[1]],dp[[1]])
        expect_equal(sum(sims[[2]][dp[[2]]==0]),0)
    }

    # test with the stationary and the transition probabilities
    for (m in seq(1,3)) {
        bg=readBackground(seqs, m)


        # simluate score distribution and
        # compute exact score distribution
        dp=scoreDist(motif[,1:(m+1)],bg)
        bf=scoreDistBf(motif[,1:(m+1)],bg)
        sims=scoreDistEmpirical(motif[,1:(m+1)],bg,m+1,1000)


        expect_equal(sum(dp[[2]]),1)
        expect_equal(bf[[1]],dp[[1]])
        expect_equal(bf[[2]],dp[[2]])

        expect_equal(sims[[1]],dp[[1]])
        # for impossible scores, check if sampling indeed
        # yields no observations
        expect_equal(sum(sims[[2]][dp[[2]]==0]),0)

    }
})

test_that("further scoreDist checks with jaspar motifs", {
    library(MotifDb)
    motifs=as.list(query(query(MotifDb,"hsapiens"),"JASPAR_CORE"))

    # Load sequences
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs, 1)

    for ( motif in motifs ) {
        motif=normalizeMotif(motif)
        if (ncol(motif)>4) {
            motif=motif[, 1:4]
        }
        dp=scoreDist(as.matrix(motif),bg)
        bf=scoreDistBf(as.matrix(motif),bg)

        expect_equal(dp$dist, bf$dist)
        expect_equal(sum(dp$dist),1)

        expect_true(dp$dist[1]>0)
        expect_true(dp$dist[length(dp[[2]])]>0)
    }
})

test_that("scoreSequence", {
    # This implicitly tests scoreStrand as well,
    # so no separate tests are available

    # Set the significance level and granularity for the score computation
    motifcounterOptions(alpha=0.01,gran=0.1)

    # Load sequences
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs,1)

    # Load motif
    motiffile=system.file("extdata","x31.tab",package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # no motif, not background object, no DNAString
    expect_error(scoreSequence(seqs,motif,1))
    expect_error(scoreSequence(seqs,1,bg))
    expect_error(scoreSequence("a",motif,bg))

    # expect error with too short sequence
    scores=scoreSequence(generateDNAString(ncol(motif)-1,bg),motif,bg)
    expect_equal(length(scores[[1]]),0)
    expect_equal(length(scores[[2]]),0)
    scores=scoreSequence(Biostrings::DNAString(""),motif,bg)
    expect_equal(length(scores[[1]]),0)
    expect_equal(length(scores[[2]]),0)

    # check motif shorter than bg order
    bg=readBackground(seqs,2)
    expect_error(scoreSequence(seqs,as.matrix(motif[, 1]),bg)[[1]])

    # Reload background
    bg=readBackground(seqs,1)

    seq=generateDNAString(10,bg)

    # Compute score sequence
    scores=scoreSequence(seq,motif,bg)

    # same number of positions on both strands
    scores=scoreSequence(seq,motif,bg)
    expect_equal(length(scores$fscores),length(scores$rscores))

    # and length is Nscores= Nseq-Nmotif+1
    expect_equal(length(scores$fscores),10-ncol(motif)+1)

    # If sequence contains 'N', the respective scores should be NaN
    seq=Biostrings::replaceLetterAt(seq,3,"N")
    scores=scoreSequence(seq,motif,bg)
    expect_equal(scores$fscores,scores$rscores) # both should be equal
    expect_equal(scores$fscores, rep(NaN, 3))
    expect_equal(length(scores$fscores),3) # length=3
    expect_equal(length(scores$rscores),3) # length=3
})

test_that("scoreProfile", {
    # init
    alpha=0.01
    gran=0.1
    motifcounterOptions(alpha, gran)

    # Load seqs
    seqfile=system.file("extdata","test2.fa", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load Background
    bg=readBackground(seqs,1)

    # palindrom
    name="x3.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))

    # error because it is no DNAStringSet
    # This was updated. It used to only accept DNAStringSet,
    # but now, DNAStringSet and DNAString is accepted.
    scoreProfile(seqs[[1]],motif,bg)

    # error because unequal sequence length
    expect_error(scoreProfile(seqs[1:2],motif,bg))

    # Check too short sequence
    expect_equal(length(scoreProfile(
                Biostrings::DNAStringSet(""),motif,bg)[[1]]),0)
    expect_equal(length(scoreProfile(
                Biostrings::DNAStringSet(""),motif,bg)[[2]]),0)
    expect_equal(length(scoreProfile(
                generateDNAStringSet(ncol(motif)-1,bg),motif,bg)[[1]]),0)
    expect_equal(length(scoreProfile(
                generateDNAStringSet(ncol(motif)-1,bg),motif,bg)[[2]]),0)

    # check motif shorter than bg order
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs2=Biostrings::readDNAStringSet(seqfile)
    bg=readBackground(seqs2,2)
    expect_error(scoreProfile(seqs,as.matrix(motif[, 1]),bg)[[1]])

    # Reload background
    bg=readBackground(seqs,1)

    # Test correct hit positions
    mh=scoreProfile(seqs[1], motif,bg)
    # because it is a palindrome
    expect_equal(mh[[1]],mh[[2]])
    expect_equal(which(mh[[1]]==max(mh[[1]])),13)

    # no hit in the second sequence
    mh=scoreProfile(seqs[2], motif,bg)
    expect_equal(mh[[1]],mh[[2]])
    expect_equal(length(mh[[1]]),length(seqs[[2]])-ncol(motif)+1)

    # NaN due to 'N'
    mh=scoreProfile(seqs[3], motif,bg)
    expect_equal(c(length(mh[[1]]),length(mh[[2]])),c(10,10))
    expect_equal(mh[[1]],c(-23.0, NaN,NaN,NaN,NaN,NaN,NaN,-14.7,-21.3,-14.8))

    # Check with aaa repeat motif
    name="x8.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))

    profile=scoreProfile(seqs[2],motif,bg)
    expect_equal(length(profile[[2]]),length(profile[[1]]))
    expect_equal(length(profile[[1]]),length(seqs[[2]])-ncol(motif)+1)
    # in the forward strand one hit
    expect_equal(which(profile[[1]]==max(profile[[1]])),4)

})

test_that("scoreHistogram", {
    # This part implicitly also tests scoreHistogramSingleSeq

    # Set the significance level
    motifcounterOptions(alpha=0.01,gran=0.1)

    # Load sequences
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs,1)


    # Load motif
    motiffile=system.file("extdata","x31.tab",package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # Provoke an error
    expect_error(scoreHistogram(seqfile,motif,bg)) # not a DNAStringSet

    # error because it is no DNAStringSet
    # This was updated. It used to only accept DNAStringSet,
    # but now, DNAStringSet and DNAString is accepted.
    scoreHistogram(seqs[[1]],motif,bg)

    # check motif shorter than bg order
    bg=readBackground(seqs,2)
    expect_error(scoreHistogram(seqs,as.matrix(motif[, 1]),bg))

    # Reload background
    bg=readBackground(seqs,1)

    # Check short sequence must yield only zeros
    dp=scoreDist(as.matrix(motif),bg)
    expect_equal(scoreHistogram(
                Biostrings::DNAStringSet(""),motif,bg)$dist,
                rep(0,length(dp[[1]])))
    expect_equal(scoreHistogram(
                generateDNAStringSet(ncol(motif)-1,bg),motif,bg)$dist,
                rep(0,length(dp[[1]])))

    # scoreHistogram same range as scoreDist
    dp=scoreDist(as.matrix(motif),bg)
    seqs=generateDNAStringSet(10,bg)
    sh=scoreHistogram(seqs,motif,bg)

    expect_equal(sh[[1]],dp[[1]])

    # Check total number of scores
    expect_equal(sum(sh$dist),10-ncol(motif)+1)

    # Insert an 'N' must yield zero observations
    seq=Biostrings::replaceLetterAt(seqs[[1]],3,"N")
    sh=scoreHistogram(Biostrings::DNAStringSet(seq),motif,bg)
    expect_equal(sh$dist,rep(0,length(dp[[1]])))
    expect_equal(sh[[1]],dp[[1]])

    # Test set of sequences
    seqs=generateDNAStringSet(rep(30,100),bg)

    sh=scoreHistogram(seqs,motif,bg)
    expect_equal(sum(sh$dist),(30-ncol(motif)+1)*100) # number of observed

})

test_that("scoreThreshold", {

    # Set the significance level and granularity for the score computation
    motifcounterOptions(alpha=0.01,gran=0.1)

    # Load sequences
    seqfile=system.file("extdata","seq.fasta", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs,1)

    # Load  motif
    motiffile=system.file("extdata","x31.tab",package="motifcounter")
    motif=t(as.matrix(read.table(motiffile)))

    # check motif shorter than bg order
    bg=readBackground(seqs,2)
    expect_error(scoreThreshold(as.matrix(motif[, 1]),bg))

    # Reload background
    bg=readBackground(seqs,1)

    # Test plausibility of threshold
    sth=scoreThreshold(motif,bg)
    expect_true(sth$alpha<=0.01)

    # Use different sequence
    seqfile=system.file("extdata","test2.fa", package="motifcounter")
    seqs=Biostrings::readDNAStringSet(seqfile)

    # Load background
    bg=readBackground(seqs,0)

    # Load motif
    name="x8.tab"
    file=system.file("extdata",name, package="motifcounter")
    motif=t(as.matrix(read.table(file)))

    # try too stringent
    motifcounterOptions(alpha=0.001,gran=0.1)
    expect_error(scoreThreshold(motif,bg))

    # retry with stringent threshold
    motifcounterOptions(alpha=0.01,gran=0.1)
    scoreThreshold(motif,bg)
})

---
title: "Introduction to the `motifcounter` package"
author: "Wolfgang Kopp"
date: "2017-10-06"
output:
    prettydoc::html_pretty:
        toc: TRUE
        number_sections: TRUE
        fig_caption: yes
        fig_height: 4
        fig_width: 6
        css: motifcounter.css
vignette: >
    %\VignetteIndexEntry{Introduction to the `motifcounter` package}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
#bibliography: literature.bib
---


```{r include=FALSE}
library(knitr)
knit_hooks$set(plot = function(x, options) {
    paste('<figure><img src="',
        opts_knit$get('base.url'), paste(x, collapse = '.'),
        '"><figcaption>', options$fig.cap, '</figcaption></figure>',
        sep = '')
})
library(motifcounter)
library(MotifDb)
library(seqLogo)
opts_chunk$set(fig.path="fig/")
```


This software package grew out of the work that I did to obtain my PhD.
If it is of help for your analysis, please cite
```
@Manual{,
    title = {motifcounter: R package for analysing TFBSs in DNA sequences},
    author = {Wolfgang Kopp},
    year = {2017},
    doi = {10.18129/B9.bioc.motifcounter}
}
```

Details about the compound Poisson model are available under
```
@article{improvedcompound,
  title={An improved compound Poisson model for the number of motif hits in DNA sequences},
  author={Kopp, Wolfgang and Vingron, Martin},
  journal={Bioinformatics},
  pages={btx539},
  year={2017},
  publisher={Oxford University Press}
}
```
# Usage examples

```{r eval=FALSE}
# Estimate a background model on a set of sequences
bg <- readBackground(sequences, order)
```
```{r eval=FALSE}
# Normalize a given PFM
new_motif <- normalizeMotif(motif)
```
```{r eval=FALSE}
# Evaluate the scores along a given sequence
scores <- scoreSequence(sequence, motif, bg)
```
```{r eval=FALSE}
# Evaluate the motif hits along a given sequence
hits <- motifHits(sequence, motif, bg)
```
```{r eval=FALSE}
# Evaluate the average score profile
average_scores <- scoreProfile(sequences, motif, bg)
```
```{r eval=FALSE}
# Evaluate the average motif hit profile
average_hits <- motifHitProfile(sequences, motif, bg)
```
```{r eval=FALSE}
# Compute the motif hit enrichment
enrichment_result <- motifEnrichment(sequences, motif, bg)
```

# Introduction


## Biological background

Transcription factors (TFs) play a crucial role in gene regulation.
They function by recognizing and binding to specific DNA stretches
that are usually 5-30bp in length
which are referred to as *transcription factor binding sites* (TFBSs).
TF-binding acts on the neighboring
genes by up- or down-regulating their gene expression levels.

The aim of the `motifcounter` package is to provide statistical
tools for studying putative TFBSs in given DNA sequence, including
the presence and location of TFBSs and the enrichment of TFBSs.

## Hallmarks of `motifcounter`

The main ingredients for an analysis with `motifcounter` consist of

1. a position frequency matrix (PFM) (also called TF motif)
2. a background model that serves as a reference for the statistical analysis
3. a set of DNA sequences that is subject to the TFBS analysis
4. a *false positive probability* $\alpha$ for predicting TFBSs
    in a random sequence. E.g. $\alpha=0.001$.

A **PFM** represents the affinity of a TF to bind a certain DNA segment. A
large set of known PFMs can be acquired e.g. from 
the `MotifDb` package [@motifdb].
On the other hand,
the **background model** defines the properties of unbound DNA sequences.
`motifcounter` implements the background model as an
**order-$d$ Markov model**, where $d$ is prescribed by the user.
The advantage of using higher-order background models is that they
are able to capture higher-order sequence features which is crucial
for studying naturally occurring DNA sequences (e.g. CpGs islands).

Using the PFM and the background model, `motifcounter` computes
the **motif score** for a given DNA sequence,
which is defined to be the log-likelihood ratio 
between the PFM and the background.
The motif score represents a measure that indicates whether a certain
position in the DNA sequence is bound or unbound by the TF. Intuitively, 
the higher the score, the more like does the sequence represent a TFBS.

The motif scores are also used to determine
**motif hits** (e.g. putative TFBSs) in the DNA sequence.
To this end, `motifcounter`
uses a predetermined **score threshold** 
and calls putative TFBSs whenever the observed score at a give 
position is greater or equal to the score threshold.
`motifcounter` establishes the **score threshold**
automatically based on 1) the
**score distribution** and 2) the user-prescribed false positive level $\alpha$.
To this end, the score distribution is determined by
an efficient dynamic programming algorithm for general order-$d$
background models. Details of the algorithm are described our paper (see above).

Testing for **motif hit enrichment** in `motifcounter` is based
on the **number of motif hits** that are observed in a set of DNA sequences.
In order to be able to judge significance of the observed number of hits 
(e.g. 10 predicted TFBSs in the sequence of length 10kb), 
the package approximates the  **distribution of the number of motif hits** 
in random DNA sequences with matched lengths.

Accordingly, `motifcounter` provides two fast and accurate alternatives
for approximating this distribution:

1. A compound Poisson approximation (see Kopp and Vingron (2017) Bioinformatics.)
2. A combinatorial model (manuskript in preparation)

Both of these methods support higher-order background models and
account for the **self-overlapping** structure of the motif.
For example, a repeat-like word, e.g. 'AAAA', likely gives rise to a string of mutually overlapping hits which  
are referred to as **clumps** [@reinert, @pape]^[
By contrast, a simple binomial approximation  [@rsat1,@rahmann] 
does not account for self-overlapping matches.].
`motifcounter` not only account for overlapping motif hits
with respect to a single DNA strand, but also 
for overlapping reverse complementary hits,
if both DNA strands are scanned for motif hits.
It is essential
to account for clumping, as that influences the distribution
of the number of motif hits and thereby the motif hit enrichment test. 
Ignoring this effect could cause misleading statistical conclusions.





# Getting started
## Preliminary steps
### Acquire a background model
The background model is used to specify the 
properties of unbound DNA sequences. That is, it 
plays a role as a reference
for identifying putative TFBSs as well as for judging
motif hit enrichment.

`motifcounter` offers the opportunity to use
order-$d$ Markov model with user-defined $d$.
The background model is estimated on a set of user-provided
DNA sequences which are supplied as 
`DNAStringSet`-objects from the `Biostrings` Bioconductor package.

The following code fragment illustrates how an order-$1$ 
background model is estimated from a given set of DNA sequences:
```{r}
order <- 1
file <- system.file("extdata", "seq.fasta", package = "motifcounter")
seqs <- Biostrings::readDNAStringSet(file)
bg <- readBackground(seqs, order)
```

<div class="hint">
**Hint:** Ideally, the DNA sequence for 
estimating the background model should be representative (or even the same)
as the sequences that are latter analysed (e.g. for motif hit enrichment).
</div>
<br>
<div class="hint">
**Hint:** For the purpose of motif enrichment testing, 
we recommend to use orders $d=1$ or $d=2$. Using a background with 
very high order $d$ might be very costly to compute and, more importantly,
due to its increased flexibility, might capture relevant TFBS signals.
In that case, enriched motifs might not be recovered.
</div>
### Acquire a motif
`motifcounter` handles motifs in terms of 
*position frequency matrices* (PFMs), which are commonly
used to represent the binding affinity of transcription factors (TFs).

A convenient source of known motifs is the `MotifDb` 
Bioconductor package [@motifdb],
which shall be the basis for our tutorial.
For example, we retrieve the motif for the human *Pou5f1* (or *Oct4*) 
transcription factor as follows


```{r}
# Extract the Oct4 motif from MotifDb
library(MotifDb)
oct4 <- as.list(query(query(query(MotifDb, "hsapiens"), 
                "pou5f1"), "jolma2013"))[[1]]
motif <- oct4

# Visualize the motif using seqLogo
library(seqLogo)
seqLogo(motif)
```

<div class="hint">
**Hint:** `motifcounter` requires strictly positive entries for a PFM.
If this is not the case, the package provides
the function `normalizeMotif`, which adds
pseudo-observations and re-normalize the columns:

```{r}
new_motif <- normalizeMotif(motif)
```
</div>


### Optional settings

By default, `motifcounter` identifies TFBS with a 
the false positive probability of $\alpha=0.001$. 
The user might want to change 
the stringency level of $\alpha$, which is facilitated by `motifcounterOptions`:

```{r eval=FALSE}
alpha <- 0.01
motifcounterOptions(alpha)
```

For other options consult `?motifcounterOptions`.



## Retrieve position- and strand-specific scores and hits

For the following example, we explore the DNA sequences of 
a set of *Oct4*-ChIP-seq peaks that were obtained in human *hESC* by 
the ENCODE project [@encode2012]. The peak regions were trimmed to 200 bps centered around the midpoint.

```{r}
file <- system.file("extdata", "oct4_chipseq.fa", package = "motifcounter")
oct4peaks <- Biostrings::readDNAStringSet(file)
```

### Analysis of individual DNA sequences

The `motifcounter` package provides functions for exploring 
position- and strand-specific putative TFBSs in individual DNA sequences.
One way to explore a given DNA sequence for TFBSs is by 
utilizing `scoreSequence`. This function returns the per position and 
strand scores  for a given `Biostring::DNAString`-object 
(left panel below).
To put the observed scores into perspective, the right panel shows
the theoretical score distribution in random sequences, which
is obtained by `scoreDist`^[The score distribution is computed using an 
efficient dynamic programming algorithm.]. Scores at the tail of 
the distribution occur very rarely by chance. 
Those are also the ones that give rise to TFBS predictions:

```{r fig.show=TRUE, fig.cap="Per-position and strand scores"}
# Determine the per-position and per-strand scores
scores <- scoreSequence(oct4peaks[[1]], motif, bg)

# As a comparison, compute the theoretical score distribution
sd <- scoreDist(motif, bg)

par(mfrow = c(1, 2))
# Plot the observed scores, per position and per strand
plot(1:length(scores$fscores), scores$fscores, type = "l", 
    col = "blue", xlab = "position", ylab = "score", 
    ylim = c(min(sd$score), max(sd$score)), xlim = c(1, 250))
points(scores$rscores, col = "red", type = "l")
legend("topright", c("forw.", "rev."), col = c("blue", "red"), lty = c(1, 1))

# Plot the theoretical score distribution for the comparison
plot(sd$dist, sd$scores, type = "l", xlab = "probability", ylab = "")
```

To obtain the predicted TFBSs positions and strands, `motifcounter` provides
the function `motifHits`. This function calls motif hits
if the observed score exceeds a pre-determined score 
threshold^[The threshold is determined for a user-defined false 
positive level $\alpha$ (e.g. $\alpha=0.001$) based on 
the theoretical score distribution.].

```{r}
# Call putative TFBSs
mhits <- motifHits(oct4peaks[[1]], motif, bg)

# Inspect the result
fhitpos <- which(mhits$fhits == 1)
rhitpos <- which(mhits$rhits == 1)
fhitpos
rhitpos
```
In the example sequence, we obtain no motif hit on the forward strand and 
one motif hit on the reverse strand at position 94. 
The underlying DNA sequence at this hit can be retrieved by

```{r}
oct4peaks[[1]][rhitpos:(rhitpos + ncol(motif) - 1)]
```

Next, we illustrate how a relaxed stringency level influences 
the number of motif hits. Using `motifcounterOptions`, we prescribe a
false positive probability of $\alpha=0.01$ (the default was $\alpha=0.001$).
This will increase the tendency of producing motif hits

```{r}
# Prescribe a new false positive level for calling TFBSs
motifcounterOptions(alpha = 0.01)

# Determine TFBSs
mhits <- motifHits(oct4peaks[[1]], motif, bg)

fhitpos <- which(mhits$fhits == 1)
rhitpos <- which(mhits$rhits == 1)
fhitpos
rhitpos
```
Now we obtain four hits on each strand.

### Analysis of a set of DNA sequences

While, `scoreSequence` and `motifHits` can be applied to study 
TFBSs in a single DNA sequence (given by a `DNAString`-object), 
one might also be interested in the 
average score or motif hit profiles across multiple sequences of equal length.
This might reveal positional constraints of the motif occurrences 
with respect to e.g. the TSS, or the summit of ChIP-seq peaks.
On the one hand,
`motifcounter` provides the method `scoreProfile` 
which can be applied for `Biostrings::DNAStringSet`-objects.

```{r fig.show=TRUE, fig.cap="Average score profile"}
# Determine the average score profile across all Oct4 binding sites
scores <- scoreProfile(oct4peaks, motif, bg)

plot(1:length(scores$fscores), scores$fscores, type = "l", 
    col = "blue", xlab = "position", ylab = "score")
points(scores$rscores, col = "red", type = "l")
legend("bottomleft", legend = c("forward", "reverse"), 
    col = c("blue", "red"), lty = c(1, 1))
```

On the other hand, `motifHitProfile` constructs a similar profile by computing
the position and strand specific mean motif hit frequency

```{r fig.show=TRUE, fig.cap="Average motif hit profile"}
motifcounterOptions()  # let's use the default alpha=0.001 again

# Determine the average motif hit profile
mhits <- motifHitProfile(oct4peaks, motif, bg)

plot(1:length(mhits$fhits), mhits$fhits, type = "l", 
    col = "blue", xlab = "position", ylab = "score")
points(mhits$rhits, col = "red", type = "l")
legend("bottomleft", legend = c("forward", "reverse"), 
    col = c("blue", "red"), lty = c(1, 1))
```


## Test for motif hit enrichment

A central feature of `motifcounter` represents a sophisticated
novel approach for identifying motif hit enrichment in DNA sequences.

To this end, the package contains the method `motifEnrichment`,
which evaluates the *P-value* associated with the number of motif hits
that are found in the observed sequence, compared to the background model.

```{r}
# Enrichment of Oct4 in Oct4-ChIP-seq peaks
result <- motifEnrichment(oct4peaks[1:10], motif, bg)
result
```

The method returns a list that contains
`pvalue` as well as `fold`. While, the `pvalue` represents
the probability that more or equally many hits are produced in 
random DNA sequences, `fold` represents the fold-enrichment of 
motif hits relative the 
expected number of hits in random DNA sequences.
That is, it represents a measure of the effect size.

<div class="hint">
**Hint:** In case, very long or many DNA sequences are scanned for
TFBSs, the distribution of the number of motif hits becomes very narrow.
In that case, the tiniest differences between the observed and the 
expected number of hits give rise to very small *P-values*.
In this case, the fold-enrichment should be consulted to reveal
if the effect size is of biological relevance.
</div>
<br>
<div class="hint">
**Hint:** By default, `motifEnrichment` scans both DNA strands 
for motif hits and draws its statistical conclusions based 
on the compound Poisson model. However, motif enrichment can 
also be performed with respect to scanning
single strands (e.g. when analyzing RNA sequences).
Please consult `?motifEnrichment` for the single strand option.
</div>
<br>
<div class="hint">
**Hint:** `motifEnrichment` may optionally invoke two alternative approaches for
approximating the *P-value*, 1) by a **compound Poisson approxmiation**
and 2) by a **combinatorial approximation** (see `?motifEnrichment`).
As a rule of thumb, we recommend the use 
compound Poisson model for studying long (or many ) DNA sequences with
a fairly stringent $\alpha$ (e.g. 0.001 or smaller).
On the other hand, if a relaxed $\alpha$ is 
desired for your analysis (e.g $\alpha\geq 0.01$),
the **combinatorial approximation** is likely to give more accurate results.
</div>
<div class="hint">
**Hint:** We recommend against using too relaxed choices for $\alpha$ (e.g $\alpha\geq 0.05$), as this violates some of the assumptions on which
the models are based on. The consequence might be significant biases of the results.
</div>

# Session Info

```{r sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/score_wrapper.R
\name{scoreDist}
\alias{scoreDist}
\title{Score distribution}
\usage{
scoreDist(pfm, bg)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}
}
\value{
List that contains
\describe{
\item{scores}{Vector of scores}
\item{dist}{Score distribution}
}
}
\description{
This function computes the score distribution for the given PFM and
background. The Score distribution is computed based on an efficient
dynamic programming algorithm.
}
\examples{


# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Compute the score distribution
dp = scoreDist(motif, bg)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/score_wrapper.R
\name{scoreProfile}
\alias{scoreProfile}
\title{Score profile across multiple sequences}
\usage{
scoreProfile(seqs, pfm, bg)
}
\arguments{
\item{seqs}{A DNAStringSet or DNAString object}

\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}
}
\value{
List containing
\describe{
\item{fscores}{Vector of per-position average forward strand scores}
\item{rscores}{Vector of per-position average reverse strand scores}
}
}
\description{
This function computes the per-position and per-strand
average score profiles across a set of DNA sequences.
It can be used to reveal positional constraints
of TFBSs.
}
\examples{


# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Compute the score profile
scoreProfile(seqs, motif, bg)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/overlap.R
\docType{class}
\name{Overlap-class}
\alias{Overlap-class}
\alias{.Overlap}
\title{Overlap class definition}
\description{
Objects of this class serve as a container that holds
parameters for the overlapping hit probabilities.
}
\details{
An Overlap object is constructed via the \code{\link{probOverlapHit}}
}
\section{Slots}{

\describe{
\item{\code{alpha}}{Scalar numeric significance level to call motif matches}

\item{\code{beta}}{Numeric vector of 
principal overlapping hit probabilities on the same strand.}

\item{\code{beta3p}}{Numeric vector of
principal overlapping hit probabilities with 3'-overlap.}

\item{\code{beta5p}}{Numeric vector of
principal overlapping hit probabilities with 5'-overlap.}

\item{\code{gamma}}{Numeric vector of marginal overlapping hit probabilities.}

\item{\code{singlestranded}}{logical flag to indicate whether one
or both strands are scanned for motif matches.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichmentTest.R
\name{motifEnrichment}
\alias{motifEnrichment}
\title{Enrichment of motif hits}
\usage{
motifEnrichment(seqs, pfm, bg, singlestranded = FALSE, method = "compound")
}
\arguments{
\item{seqs}{A DNAStringSet or DNAString object}

\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}

\item{singlestranded}{Boolean that indicates whether a single strand or
both strands shall be scanned for motif hits.
Default: singlestranded = FALSE.}

\item{method}{String that defines whether to use
the 'compound' Poisson approximation' or the 'combinatorial' model.
Default: method='compound'.}
}
\value{
List that contains
\describe{
\item{pvalue}{P-value for the enrichment test}
\item{fold}{Fold-enrichment with respect to the expected number of hits}
}
}
\description{
This function determines whether a given motif is enriched in a given
DNA sequences.
}
\details{
Enrichment is tested by comparing the observed 
number of motif hits against a theoretical distribution of the number
of motif hits in random DNA sequences.
Optionally, the theoretical distribution of the number of motif
hits can be evaluated by either a 'compound Poisson model' 
or the 'combinatorial model'.
Additionally, the enrichment test can be conducted with respect
to scanning only the forward strand or both strands of the DNA
sequences. The latter option is only available for the
'compound Poisson model'
}
\examples{


# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# 1 ) Motif enrichment test w.r.t. scanning a *single* DNA strand
# based on the 'Compound Poisson model'

result = motifEnrichment(seqs, motif, bg,
            singlestranded = TRUE, method = "compound")

# 2 ) Motif enrichment test w.r.t. scanning *both* DNA strand
# based on the 'Compound Poisson model'

result = motifEnrichment(seqs, motif, bg, method = "compound")

# 3 ) Motif enrichment test w.r.t. scanning *both* DNA strand
# based on the *combinatorial model*

result = motifEnrichment(seqs, motif, bg, singlestranded = FALSE,
            method = "combinatorial")

}
\seealso{
\code{\link{compoundPoissonDist}}, \code{\link{combinatorialDist}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/forground_wrapper.R
\name{normalizeMotif}
\alias{normalizeMotif}
\title{Normalizes a PFM}
\usage{
normalizeMotif(pfm, pseudo = 0.01)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}

\item{pseudo}{Small numeric pseudo-value that is added
to each entry in the PFM in order to ensure strictly positive entries.
Default: pseudo = 0.01}
}
\value{
A normalized PFM
}
\description{
This function normalizes a PFM and optionally
adds pseudo-evidence to each entry of the matrix.
}
\examples{

# Load motif
motiffile = system.file("extdata", "x1.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Normalize motif
new_motif = normalizeMotif(motif)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/score_wrapper.R
\name{scoreThreshold}
\alias{scoreThreshold}
\title{Score threshold}
\usage{
scoreThreshold(pfm, bg)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}
}
\value{
List containing
\describe{
\item{threshold}{Score threshold}
\item{alpha}{False positive probability}
}
}
\description{
This function computes the score threshold for a desired
false positive probability `alpha`.
}
\details{
Note that the returned alpha usually differs slightly
from the one that is prescribed using
\code{\link{motifcounterOptions}}, because
of the discrete nature of the sequences.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Compute the score threshold
motifcounter:::scoreThreshold(motif, bg)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/score_wrapper.R
\name{scoreStrand}
\alias{scoreStrand}
\title{Score strand}
\usage{
scoreStrand(seq, pfm, bg)
}
\arguments{
\item{seq}{A DNAString object}

\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}
}
\value{
\describe{
\item{scores}{Vector of scores on the given strand}
}
}
\description{
This function computes the per-position
score in a given DNA strand.
}
\details{
The function returns the per-position scores
for the given strand. If the sequence is too short,
it contains an empty vector.
}
\examples{


# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Compute the per-position and per-strand scores
motifcounter:::scoreStrand(seqs[[1]], motif, bg)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulate_wrapper.R
\name{generateDNAString}
\alias{generateDNAString}
\title{Generate DNAString}
\usage{
generateDNAString(len, bg)
}
\arguments{
\item{len}{Integer length of the sequence}

\item{bg}{A Background object}
}
\value{
A DNAString object
}
\description{
This function generates a random DNAString of a given length
by sampling from the background model.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Generate a 1 kb random sequence
motifcounter:::generateDNAString(1000, bg)

}
\seealso{
\code{\link{generateDNAStringSet}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulate_wrapper.R
\name{simulateNumHitsDist}
\alias{simulateNumHitsDist}
\title{Empirical number of motif hits distribution}
\usage{
simulateNumHitsDist(pfm, bg, seqlen, nsim, singlestranded = FALSE)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}

\item{seqlen}{Integer-valued vector that defines the lengths of the
individual sequences. For a given DNAStringSet, 
this information can be retrieved using \code{\link{numMotifHits}}.}

\item{nsim}{Integer number of random samples.}

\item{singlestranded}{Boolean that indicates whether a single strand or
both strands shall be scanned for motif hits.
Default: singlestranded = FALSE.}
}
\value{
A List that contains
\describe{
\item{dist}{Empirical distribution of the number of motif hits}
}
}
\description{
This function repeatedly simulates random DNA sequences according to
the background model and
subsequently counts how many motif hits occur in them.
Thus, this function gives rise to the empirical
distribution of the number of motif hits.
This function is only used for benchmarking analysis.
}
\examples{


# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Study the counts in one sequence of length 150 bp
seqlen = rep(150, 1)

# Compute empirical distribution of the number of motif hits
# by scanning both strands using 100 samples
simc = motifcounter:::simulateNumHitsDist(motif, bg,
    seqlen, nsim = 100, singlestranded = FALSE)

# Compute empirical distribution of the number of motif hits
# by scanning a single strand using 100 samples
simc = motifcounter:::simulateNumHitsDist(motif, bg,
    seqlen, nsim = 100, singlestranded = TRUE)

}
\seealso{
\code{\link{compoundPoissonDist}},\code{\link{combinatorialDist}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/forground_wrapper.R
\name{revcompMotif}
\alias{revcompMotif}
\title{Reverse complements a PFM}
\usage{
revcompMotif(pfm)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}
}
\value{
Reverse complemented PFM
}
\description{
This function computes the reverse complement of a given PFM.
}
\examples{

# Load motif
motiffile = system.file("extdata", "x1.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Reverse complement motif
revcompmotif = motifcounter:::revcompMotif(motif)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/comppoiss_wrapper.R
\name{clumpSizeDist}
\alias{clumpSizeDist}
\title{Clump size distribution}
\usage{
clumpSizeDist(maxclump, overlap, method = "kopp")
}
\arguments{
\item{maxclump}{Maximal clump size}

\item{overlap}{An Overlap object.}

\item{method}{String that defines which method shall be invoked: 'pape' or
'kopp' (see description). Default: method = 'kopp'.}
}
\value{
List containing
\describe{
\item{dist}{Distribution of the clump size}
}
}
\description{
This function approximates the distribution of the clump sizes.
}
\details{
The clump size distribution can be determined in two alternative ways:
\enumerate{
\item A re-implemented version of the algorithm that was
described in Pape et al. \emph{Compound poisson approximation
of the number of occurrences of a position
frequency matrix (PFM) on both strands.} 2008
can be invoked using method='pape'.
\item An improved approximation of the clump size distribution 
uses more appropriate statistical assumptions concerning
overlapping motif hits and that can be used with order-d
background models as well. The improved version is used by default
with method='kopp'.
}
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Load background model
bg = readBackground(seqs, 1)

# Use 100 individual sequences of length 150 bp each
seqlen = rep(150, 100)


# Compute overlapping probabilities
# for scanning the forward DNA strand only
op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)

# Computes  the compound Poisson distribution
dist = motifcounter:::clumpSizeDist(20, op)

}
\seealso{
\code{\link{probOverlapHit}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/score_wrapper.R
\name{scoreDistBf}
\alias{scoreDistBf}
\title{Score distribution}
\usage{
scoreDistBf(pfm, bg)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}
}
\value{
List containing
\describe{
\item{scores}{Vector of scores}
\item{dist}{Score distribution}
}
}
\description{
This function computes the score distribution for a given PFM and
a background model.
}
\details{
The result of this function is identical to \code{\link{scoreDist}},
however, the method employs a less efficient algorithm that
enumerates all DNA sequences of the length of the motif.
This function is only used for debugging and testing purposes
and might require substantial computational
resources for long motifs.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Compute the score distribution
dp = motifcounter:::scoreDistBf(motif, bg)

}
\seealso{
\code{\link{scoreDist}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/forground_wrapper.R
\name{motifAndBackgroundValid}
\alias{motifAndBackgroundValid}
\title{Check valididity of PFM with background}
\usage{
motifAndBackgroundValid(pfm, bg)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}
}
\value{
None
}
\description{
This function checks if the PFM x background combination is valid.
The function throws an error if this is not the case.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x1.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Check validity
motifcounter:::motifAndBackgroundValid(motif, bg)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motifcounter-package.R
\docType{package}
\name{motifcounter-package}
\alias{motifcounter-package}
\alias{motifcounter}
\title{TFBSs analysis in DNA sequences}
\description{
The package provides functions for determining the positions
of motif hits as well as motif hit
enrichment for a given position frequency matrix (PFM)
in a DNA sequence of interest.
The following examples guides you through the main 
functions of the `motifcounter` package.
}
\details{
For an analysis with `motifcounter`,
the user is required to provide 1) a PFM,
2) a DNA sequence which is used to estimate
a background model (see \code{link{readBackground}}),
3) a DNA sequence of interest that shall be scanned for motif hits
(can be the same as the one used for point 2),
and 4) (optionally) a desired false positive probability of motif hits in
random DNA sequences (see \code{\link{motifcounterOptions}}).

\tabular{ll}{ Package: \tab motifcounter\cr
Type: \tab Package\cr Version: \tab
1.0\cr Date: \tab 2016-11-04\cr License: \tab GPL-2\cr }
}
\examples{

# Load sequences
file = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(file)

# Estimate an order-1 background model
order = 1
bg = readBackground(seqs, order)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Normalize the motif
# Normalization is sometimes necessary to prevent zeros in
# the motif
motif = normalizeMotif(motif)

# Use subset of the sequences
seqs = seqs[1:10]

# Optionally, set the false positive probability
#alpha=0.001 # is also the default
#motifcounterOptions(alpha) 

# Investigate the per-position and per-strand scores in a given sequence
scores = scoreSequence(seqs[[1]], motif, bg)

# Investigate the per-position and per-strand motif hits in a given sequence
hits = motifHits(seqs[[1]], motif, bg)

# Determine the average score profile across a set of sequences
scores = scoreProfile(seqs, motif, bg)

# Determine the average motif hit profile across a set of sequences
hits = motifHitProfile(seqs, motif, bg)

# Determine the empirical score distribution
scoreHistogram(seqs, motif, bg)

# Determine the theoretical score distribution in random sequences
scoreDist(motif, bg)


# Determine the motif hit enrichment in a set of DNA sequences
# 1. Use the compound Poisson approximation
#    and scan only a single strand for motif hits
result = motifEnrichment(seqs, motif, bg,
            singlestranded = TRUE, method = "compound")

# Determine the motif hit enrichment in a set of DNA sequences
# 2. Use the compound Poisson approximation
#    and scan both strands for motif hits
result = motifEnrichment(seqs, motif, bg,
            singlestranded = FALSE, method = "compound")

# Determine the motif hit enrichment in a set of DNA sequences
# 3. Use the combinatorial model
#    and scan both strands for motif hits
result = motifEnrichment(seqs, motif, bg, singlestranded = FALSE,
            method = "combinatorial")

}
\author{
Wolfgang Kopp

Maintainer: Wolfgang Kopp <kopp@molgen.mpg.de>
}
\keyword{MotifEnrichment}
\keyword{PFM,}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulate_wrapper.R
\name{generateDNAStringSet}
\alias{generateDNAStringSet}
\title{Generate DNAStringSet}
\usage{
generateDNAStringSet(seqlen, bg)
}
\arguments{
\item{seqlen}{Integer-valued vector that defines the lengths of the
individual sequences. For a given DNAStringSet, 
this information can be retrieved using \code{\link{numMotifHits}}.}

\item{bg}{A Background object}
}
\value{
A DNAStringSet object
}
\description{
This function generates a DNAStringSet-object of the
given individual sequence lengths
by sampling from the background model.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Generate random sequences of various lengths
motifcounter:::generateDNAStringSet(10:50, bg)

}
\seealso{
\code{\link{generateDNAStringSet}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/overlap.R
\name{probOverlapHit}
\alias{probOverlapHit}
\title{Overlapping motif hit probabilities}
\usage{
probOverlapHit(pfm, bg, singlestranded = FALSE)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}

\item{singlestranded}{Boolean that indicates whether a single strand or
both strands shall be scanned for motif hits.
Default: singlestranded = FALSE.}
}
\value{
An Overlap object
}
\description{
This function computes a set of self-overlapping probabilites for a
motif and background model.
}
\details{
The `gamma`s are determined based on two-dimensional score 
distributions (similar as described in Pape et al. 2008),
however, they are computed based on an order-d background model.
On the other hand, the `beta`s represent overlapping hit probabilities
that were corrected for intermediate hits.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Compute overlapping hit probabilities for scanning both DNA strands
op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)

# Compute overlapping hit probabilities for scanning a single DNA strand
op = motifcounter:::probOverlapHit(motif, bg, singlestranded = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/forground_wrapper.R
\name{motifValid}
\alias{motifValid}
\title{Check valididity of PFM}
\usage{
motifValid(pfm)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}
}
\value{
None
}
\description{
This function checks if the PFM is valid. The function throws
an error if the R matrix does not represent a PFM.
}
\examples{

# Load motif
motiffile = system.file("extdata", "x1.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Check validity
motifcounter:::motifValid(motif)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/score_wrapper.R
\name{scoreHistogram}
\alias{scoreHistogram}
\title{Score histogram}
\usage{
scoreHistogram(seqs, pfm, bg)
}
\arguments{
\item{seqs}{A DNAStringSet or DNAString object}

\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}
}
\value{
List containing
\describe{
\item{scores}{Vector of scores}
\item{dist}{Score distribution}
}
}
\description{
This function computes the empirical score
distribution for a given set of DNA sequences.
}
\details{
It can be used to compare the empirical score
distribution against the theoretical one (see \code{\link{scoreDist}}).
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Compute the empirical score histogram
scoreHistogram(seqs, motif, bg)

}
\seealso{
\code{\link{scoreDist}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background_wrapper.R
\name{getCounts}
\alias{getCounts}
\title{Accessor to slot counts}
\usage{
getCounts(obj)
}
\arguments{
\item{obj}{A Background object}
}
\value{
counts slot
}
\description{
Accessor to slot counts
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background_wrapper.R
\docType{class}
\name{Background-class}
\alias{Background-class}
\alias{.Background}
\title{Background class definition}
\description{
Objects of this class serve as a container that holds
parameters for the Background model.
}
\details{
A Background model is constructed 
via \code{\link{readBackground}}.
}
\section{Slots}{

\describe{
\item{\code{station}}{Stationary probabilities}

\item{\code{trans}}{Transition probabilities}

\item{\code{counts}}{k-mer counts}

\item{\code{order}}{Background model order}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combinatorial_wrapper.R
\name{combinatorialDist}
\alias{combinatorialDist}
\title{Combinatrial model approximation of the number of motif hits}
\usage{
combinatorialDist(seqlen, overlap)
}
\arguments{
\item{seqlen}{Integer-valued vector that defines the lengths of the
individual sequences. For a given DNAStringSet, 
this information can be retrieved using \code{\link{numMotifHits}}.}

\item{overlap}{An Overlap object.}
}
\value{
List containing
\describe{
\item{dist}{Distribution of the number of hits}
}
}
\description{
This function approxmiates the distribution of the number of motif hits.
To this end, it sums over all combinations of obtaining k hits 
in a random sequence of a given length using an efficient 
dynamic programming algorithm.
}
\details{
This function is an alternative to \code{\link{compoundPoissonDist}}
which requires fixed-length sequences and currently
only supports the computation of 
the distribution of the number of hits when both
DNA strands are scanned for motif hits.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Load background model
bg = readBackground(seqs, 1)

# Compute overlap probabilities
op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)

# Use 2 sequences of length 100 bp each
seqlen = rep(100, 2) 

# Computes the combinatorial distribution of the number of motif hits
dist = motifcounter:::combinatorialDist(seqlen, op)

}
\seealso{
\code{\link{compoundPoissonDist}}

\code{\link{numMotifHits}}

\code{\link{probOverlapHit}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_wrapper.R
\name{numMotifHits}
\alias{numMotifHits}
\title{Number of motif hits in a set of DNA sequences}
\usage{
numMotifHits(seqs, pfm, bg, singlestranded = FALSE)
}
\arguments{
\item{seqs}{A DNAStringSet or DNAString object}

\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}

\item{singlestranded}{Boolean that indicates whether a single strand or
both strands shall be scanned for motif hits.
Default: singlestranded = FALSE.}
}
\value{
A list containing
\describe{
\item{nseq}{Number of individual sequences}
\item{lseq}{Vector of individual sequence lengths}
\item{numofhits}{Vector of the number of hits in each individual sequence}
}
}
\description{
This function counts the number of motif hits that
are found in a given set of DNA sequences.
}
\details{
Optionally, it can be used to count motif hits on
one or both strands, respectively.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Count motif hits both strands
noc = motifcounter:::numMotifHits(seqs, motif, bg)
noc$numofhits

# Count motif hits on a single strand
noc = motifcounter:::numMotifHits(seqs, motif, bg, singlestranded = TRUE)
noc$numofhits

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulate_wrapper.R
\name{scoreDistEmpirical}
\alias{scoreDistEmpirical}
\title{Empirical score distribution}
\usage{
scoreDistEmpirical(pfm, bg, seqlen, nsim)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}

\item{seqlen}{Integer-valued vector that defines the lengths of the
individual sequences. For a given DNAStringSet, 
this information can be retrieved using \code{\link{numMotifHits}}.}

\item{nsim}{Integer number of random samples.}
}
\value{
List containing
\describe{
\item{scores}{Vector of scores}
\item{dist}{Score distribution}
}
}
\description{
This function estimates the empirical score distribution
on a set of randomly generated DNA sequences based on the
background model.
This function is only used for benchmarking analysis.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))


# Compoute the empirical score distribution in
# sequences of length 1kb using 1000 samples
motifcounter:::scoreDistEmpirical(motif, bg, seqlen = 1000, nsim = 1000)

}
\seealso{
\code{\link{scoreDist}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_wrapper.R
\name{motifHits}
\alias{motifHits}
\title{Motif hit observations}
\usage{
motifHits(seq, pfm, bg, threshold = NULL)
}
\arguments{
\item{seq}{A DNAString object}

\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}

\item{threshold}{Score threshold for calling motif matches. If NULL,
the threshold will determined from alpha.}
}
\value{
List containing
\describe{
\item{fhits}{Per-position motif hits on the forward strand}
\item{rhits}{Per-position motif hits on the reverse strand}
}
}
\description{
This function determines per-position motif hits in a given DNA sequence.
}
\examples{


# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seq = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seq, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Determine the motif hits
motifHits(seq[[1]], motif, bg)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/overlap.R
\name{getBeta3p}
\alias{getBeta3p}
\title{Accessor to slot beta3p}
\usage{
getBeta3p(obj)
}
\arguments{
\item{obj}{An Overlap object}
}
\value{
beta3p slot
}
\description{
Accessor to slot beta3p
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background_wrapper.R
\name{getOrder}
\alias{getOrder}
\title{Accessor to slot order}
\usage{
getOrder(obj)
}
\arguments{
\item{obj}{A Background object}
}
\value{
order slot
}
\description{
Accessor to slot order
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/markovmodel.R
\name{computeClumpStartProb}
\alias{computeClumpStartProb}
\title{Computes the Clump start probability based on a Markov model}
\usage{
computeClumpStartProb(overlap)
}
\arguments{
\item{overlap}{An Overlap object.}
}
\value{
Clump start probability 'tau'
}
\description{
This function leverages a Markov model in order to
determine the clump start probability.
The computation depends on the selected false positive probability 
for calling motif matches 'alpha' and the pre-determined
overlapping match probabilities 'beta'.
}
\details{
The general idea of the method relies on the fact that
for the stationary distribution of the Markov model,
motif matches must be observed with probability 'alpha'.
Hence, the clump start probability 'tau' is optimized
to achieve that goal.

The R interface is only used for the purpose of testing
the correctness of the model.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Load background model
bg = readBackground(seqs, 1)

# Compute overlap probabilities
op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)


# Computes the clump start probability
dist = motifcounter:::computeClumpStartProb(op)

}
\seealso{
\code{\link{compoundPoissonDist}}

\code{\link{numMotifHits}}

\code{\link{probOverlapHit}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background_wrapper.R
\name{getTrans}
\alias{getTrans}
\title{Accessor to slot trans}
\usage{
getTrans(obj)
}
\arguments{
\item{obj}{A Background object}
}
\value{
trans slot
}
\description{
Accessor to slot trans
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/markovmodel.R
\name{markovModel}
\alias{markovModel}
\title{Markov model for generating Y_1Y_2_Y3 ...}
\usage{
markovModel(overlap, nsteps = 1)
}
\arguments{
\item{overlap}{An Overlap object.}

\item{nsteps}{Number of state transitions to perform}
}
\value{
List containing
\describe{
\item{dist}{State probability distribution after the given number of steps}
}
}
\description{
This function implements the Markov model for producing
motif matches. The function takes a state probability vector
and uses the transition probabilities in order to obtain
the state probability at the next time point.
This function is used used to determine the stationary distribution
of the states.
}
\details{
The R interface is only used for the purpose of testing
the correctness of the model.
}
\examples{

# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Load background model
bg = readBackground(seqs, 1)

# Compute overlap probabilities
op = motifcounter:::probOverlapHit(motif, bg, singlestranded = FALSE)


# Computes the state probabilities of the Markov model
# (default: after one step)
dist = motifcounter:::markovModel(op)

}
\seealso{
\code{\link{compoundPoissonDist}}

\code{\link{numMotifHits}}

\code{\link{probOverlapHit}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulate_wrapper.R
\name{simulateClumpSizeDist}
\alias{simulateClumpSizeDist}
\title{Empirical clump size distribution}
\usage{
simulateClumpSizeDist(pfm, bg, seqlen, nsim = 10, singlestranded = FALSE)
}
\arguments{
\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}

\item{seqlen}{Integer-valued vector that defines the lengths of the
individual sequences. For a given DNAStringSet, 
this information can be retrieved using \code{\link{numMotifHits}}.}

\item{nsim}{Integer number of random samples.}

\item{singlestranded}{Boolean that indicates whether a single strand or
both strands shall be scanned for motif hits.
Default: singlestranded = FALSE.}
}
\value{
A List that contains
\describe{
\item{dist}{Empirical distribution of the clump sizes}
}
}
\description{
This function repeatedly simulates random DNA sequences according to
the background model and
subsequently counts the number of k-clump occurrences, where
denotes the clump size.
This function is only used for benchmarking analysis.
}
\examples{


# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Study the clump size frequencies in one sequence of length 1 Mb
seqlen = 1000000

# scan both strands
simc = motifcounter:::simulateClumpSizeDist(motif, bg, seqlen)

# scan a single strand
simc = motifcounter:::simulateClumpSizeDist(motif, bg,
    seqlen, singlestranded = TRUE)

}
\seealso{
\code{\link{compoundPoissonDist}},\code{\link{combinatorialDist}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_wrapper.R
\name{hitStrand}
\alias{hitStrand}
\title{Hit strand}
\usage{
hitStrand(seq, pfm, bg, threshold = NULL)
}
\arguments{
\item{seq}{A DNAString object}

\item{pfm}{An R matrix that represents a position frequency matrix}

\item{bg}{A Background object}

\item{threshold}{Score threshold for calling motif matches. If NULL,
the threshold will determined from alpha.}
}
\value{
\describe{
\item{hits}{Vector of motif hits on the given strand}
}
}
\description{
This function computes the per-position
motif matches in a given DNA strand.
}
\details{
The function returns the per-position scores
for the given strand. If the sequence is too short,
it contains an empty vector.
}
\examples{


# Load sequences
seqfile = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(seqfile)

# Load background
bg = readBackground(seqs, 1)

# Load motif
motiffile = system.file("extdata", "x31.tab", package = "motifcounter")
motif = t(as.matrix(read.table(motiffile)))

# Compute the per-position and per-strand scores
motifcounter:::hitStrand(seqs[[1]], motif, bg)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/observed_wrapper.R
\name{lenSequences}
\alias{lenSequences}
\title{Length of sequences in a given fasta file}
\usage{
lenSequences(seqs)
}
\arguments{
\item{seqs}{A DNAStringSet object}
}
\value{
A vector containing the lengths of each individual sequences
}
\description{
The function returns a vector containing the lengths
of each sequence contained in a set of sequences. Sequences
containing 'N' or 'n' are skipped from the analysis and are
set to length zero.
}
\examples{

# Load sequences
file = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(file)

# Retrieve sequence lengths
motifcounter:::lenSequences(seqs)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/option.R
\name{sigLevel}
\alias{sigLevel}
\title{Retrieve the false positive probability}
\usage{
sigLevel()
}
\value{
False positive probability
}
\description{
This function returns the current false positive level for
calling motif hits in random sequences.
}
\details{
The returned value is usually slightly smaller than
the prescribed `alpha` in `motifcounterOptions`, because
of the discrete nature of sequences.
}
\examples{
motifcounter:::sigLevel()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/overlap.R
\name{getSinglestranded}
\alias{getSinglestranded}
\title{Accessor to slot singlestranded}
\usage{
getSinglestranded(obj)
}
\arguments{
\item{obj}{An Overlap object}
}
\value{
singlestranded slot
}
\description{
Accessor to slot singlestranded
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/option.R
\name{motifcounterOptions}
\alias{motifcounterOptions}
\title{Set parameters for the enrichment analysis}
\usage{
motifcounterOptions(alpha = 0.001, gran = 0.1, ncores = 1)
}
\arguments{
\item{alpha}{Numeric False positive probabililty for calling
motif hits by chance. Default: alpha = 0.001}

\item{gran}{Numeric score granularity which is used
for discretizing the score range. Default: gran = 0.1}

\item{ncores}{Interger number of cores used for parallel processing,
if openMP is available. Default: ncores = 1}
}
\value{
None
}
\description{
This function sets some global parameters for
the `motifcounter` package.
}
\details{
alpha=0.001 amounts to calling 
one motif hit per strand by chance in a sequence of length 1000 bp. 
Decreasing gran will increase number
of discrete bins that represent the real-valued score range.
This will yield more a accurate score distribution due to less
discretization noise, however, it incurs an 
increase of the computational burden.
}
\examples{

# Prescribe motifcounter Options
motifcounterOptions(alpha = 0.001, gran = 0.1, ncores = 1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/background_wrapper.R
\name{readBackground}
\alias{readBackground}
\title{Estimates a background model from a set of DNA sequences}
\usage{
readBackground(seqs, order = 1)
}
\arguments{
\item{seqs}{A DNAStringSet object}

\item{order}{Order of the Markov models that shall be used as the
background model. Default: order = 1.}
}
\value{
A Background object
}
\description{
Given a set of DNA sequences and an order, this function
estimates an order-d Markov model which is used to characterize
random DNA sequences.
}
\examples{

# Load sequences
file = system.file("extdata", "seq.fasta", package = "motifcounter")
seqs = Biostrings::readDNAStringSet(file)

# Estimate an order-1 Markov model
bg = readBackground(seqs, 1)

}
